--[[
                      -     =    .--._				Utility was constructed by Blaze The Cat and continued by Kitoko
                - - ~_=  =~_- = - `.  `-.			Helpers:
              ==~_ = =_  ~ -   =  .-'    `.			- NotablyPrettyCrazy: The script's crash test dummy. Always found a way to break my things.
            --=~_ - ~  == - =   .'      _..:._		- Blaze the Cat: Starting the original.
           ---=~ _~  = =-  =   `.  .--.'      `.	- Spectrum: For helping with testing.
          --=_-=- ~= _ - =  -  _.'  `.      .--.:	- Anyone else who visited the testing servers. Thank you!
            -=_~ -- = =  ~-  .'      :     :    :	
             -=-_ ~=  = - _-`--.     :  .--:    D	Well, I'm not one for words because I want to keep adding things.
               -=~ _=  =  -~_=  `;  .'.:   ,`---'@	Go ahead, have a ball.
             --=_= = ~-   -=   .'  .'  `._ `-.__.'	
            --== ~_ - =  =-  .'  .'     _.`---'		Version 0.4d
           --=~_= = - = ~  .'--''   .   `-..__.--.	
          jgs--==~ _= - ~-=  =-~_-   `-..___(  ===;	I totally stole this ASCII art
          --==~_==- =__ ~-=  - -    .'       `---'	<-- Looks like a wrench for a hand.
]]--

--Please report any and all warnings and how they happen. I strive to make this the most pester-free script possible.

--TO DO: Clean up everything and arrange them into sections.

--This is here to prevent double-adding. It could result in doubled messages and incorrect timers! That would be a mess I will not clean up for you. Nope.
assert(utility == nil, "The variable \"utility\" is already defined in the global table. Either Utility is already loaded or some script already claimed this. You need to resolve this before adding Utility!\nIn other words, you committed Utilityception.")

rawset(_G, "utility", {}) -- You can use this to check if Utility is present!

--Shows the status of this version of Utility.
utility.version = " 0.4d "
utility.iteration = " 54b"
utility.subversion = false

local rejoinkey = "EmptyStr"

local nodestatus = {} --To keep myself from checking for nil all the time.
for a=0,31 do
	nodestatus[a] = true
end

--Dediname. Is finally. Synced.
local dedicatedname = "Server"

--Helper values and various things.
utility.msg = {}
utility.msg["teamcolor"] = { --Extended team name printout by number
	[0] = "\x86" .. "%s" .. "\x80", --Spectator/Not playing at all.
	[1] = "\x82" .. "%s" .. "\x80", --Playing and unaffiliated.
	[2] = "\x85" .. "%s" .. "\x80", --Red Team
	[3] = "\x84" .. "%s" .. "\x80", --Blue Team
	[4] = "\x83" .. "%s" .. "\x80", --Not-IT
	[5] = "\x87" .. "%s" .. "\x80" --IT
}

--utility.msg["insignia"] = { --Symbols to represent permissions.
--}

utility.msg["overlay"] = { --Normal chat, team based chat, admin chat, and PMs
	[0] = "\x86" .. "[SPECT] %s " .. "\x86", --Spectator/Not playing at all.
	[1] = "\x82" .. "[NEUTRAL] %s " .. "\x82", --Playing and unaffiliated.
	[2] = "\x85" .. "[RED] %s " .. "\x85", --Red Team
	[3] = "\x84" .. "[BLUE] %s " .. "\x84", --Blue Team
	[4] = "\x83" .. "[NOT-IT] %s " .. "\x83", --Not-IT
	[5] = "\x87" .. "[IT] %s " .. "\x87", --IT
	[6] = "\x83" .. "**" .. "\x86" .. " [%s" .. "\x86" .. " -> %s" .. "\x86" .. "] %s", --Sent Private Message
	[7] = "<%s" .. "\x80" .. "> %s", --Default message.
	[8] = "\x87" .. "**" .. "\x86" .. " [%s" .. "\x86" .. " -> %s" .. "\x86" .. "] %s", --Recieved Private Message
	[9] = "\x81" .. "[ADMIN] %s " .. "\x81", --Spectator/Not playing at all.
}

utility.msg["spam"] = { --Spam silence reasons.
	[0] = "Spamming the chat.",
	[1] = "spamming the team chat.",
	[2] = "Spamming private messages.",
	[3] = "Spamming global notices.",
	[4] = "Spamming the admin chat."
}

utility.gametype = {}
utility.gametype["tol"] = { --Used in the Gametype Command. Transfers TOL and matches it with the core modes.
	[GT_COOP] = TOL_COOP,
	[GT_COMPETITION] = TOL_COMPETITION,
	[GT_RACE] = TOL_RACE,
	[GT_MATCH] = TOL_MATCH,
	[GT_TEAMMATCH] = TOL_MATCH,
	[GT_TAG] = TOL_TAG,
	[GT_HIDEANDSEEK] = TOL_TAG,
	[GT_CTF] = TOL_CTF
}

utility.gametype["names"] = { --String matches for Gametypes in conjunction with numbers.
	[GT_COOP] = "coop",
	[GT_COMPETITION] = "competition",
	[GT_RACE] = "race",
	[GT_MATCH] = "match",
	[GT_TEAMMATCH] = "teammatch",
	[GT_TAG] = "tag",
	[GT_HIDEANDSEEK] = "hideandseek",
	[GT_CTF] = "ctf"
}

--Both of these allow commands and variables to have specific additional values attached to them object-style.
utility.cmdlist = {}
utility.cmdlist["name"] = {}
utility.cmdlist["helptext"] = {}
utility.cmdlist["flags"] = {}
utility.cmdlist["num"] = 0

utility.varlist = {}
utility.varlist["name"] = {}
utility.varlist["helptext"] = {}
utility.varlist["flags"] = {}
utility.varlist["vars"] = {}
utility.varlist["num"] = 0

utility.col = {
	["white"] = "\x80",
	["purple"] = "\x81",
	["yellow"] = "\x82",
	["green"] = "\x83",
	["blue"] = "\x84",
	["red"] = "\x85",
	["grey"] = "\x86",
	["orange"] = "\x87"
}

utility.group = {}
--Default group. This is defined to keep the system happy.
--You can create, edit, and delete groups, but you cannot remove the default group.
--For permission node documentation, check the included permlist.txt
utility.group["default"] = {
	perms = {},
	title = "",
	priority = 0,
	color = "\x80",
	colstr = "white"
}

utility.helpop = {}
utility.login = {}

local function LoadDefaultPerms()
	utility.group["default"] = {
		perms = {"utility.cmd.vote.vote", "utility.cmd.vote.list", "utility.cmd.vote.start", "utility.cmd.ignore", "utility.cmd.afk", "utility.cmd.util",
			"utility.group.info", "utility.user.listperms", "utility.msg.macro", "utility.msg.public", "utility.msg.team", "utility.msg.private", "utility.msg.perms",
			"utility.cmd.helpop", "utility.login", "utility.cmd.list"},
		title = "",
		priority = 0,
		color = "\x80",
		colstr = "white"
	}
	utility.group["moderator"] = {
		perms = {"utility.cmd.vote.vote", "utility.cmd.vote.list", "utility.cmd.vote.start", "utility.cmd.ignore", "utility.cmd.afk", "utility.cmd.util",
			"utility.group.info", "utility.user.listperms", "utility.msg.macro", "utility.msg.public", "utility.msg.team", "utility.msg.private", "utility.msg.perms",
			"utility.vote.cancel", "utility.vote.permission", "utility.cmd.silence", "utility.user.listperms.other", "utility.cmd.notice", "utility.cmd.notice.clear", "utility.msg.console",
			"utility.msg.admin", "vanilla.cmd.kick", "utility.legacy.csay", "vanilla.cmd.kick.override", "utility.msg.override.slow", "utility.msg.override.ignore",
			"utility.cmd.helpop.*", "utility.cmd.vote.override", "utility.login.create"},
		title = "Mod",
		priority = 10,
		color = "\x83",
		colstr = "green"
	}
	utility.group["admin"] = {
		perms = {"utility.*", "vanilla.*"},
		title = "Admin",
		priority = 20,
		color = "\x87",
		colstr = "orange"
	}
end

LoadDefaultPerms()

--Here is an example at making a permission check in your own script.
--You may copy this function and use it anywhere you want.
local function MyPermCheck(player, permission, admin, nomsg, default)
	if utility ~= nil
		return utility.HasPerms(player, permission, admin, nomsg)
	else
		return default
	end
end

--Synchronize values with other players; these are important to us!
addHook("NetVars", function(nv)
	utility.group = nv(utility.group)
	utility.helpop = nv(utility.helpop)
	dedicatedname = nv(dedicatedname)
	utility.login = nv(utility.login)
end)

--Basic helpers for command and variable adding to give them a help text.
utility.AddUtilCommand = function(name, helptext, func, flags)
	-- Allow help for each command.
	if name == nil
	or helptext == nil
	or func == nil
	or flags == nil
	or type(name) ~= "string"
	or type(helptext) ~= "string"
	or type(func) ~= "function"
	or type(flags) ~= "number"
		print("Couldn't add a function! If the name isn't nonexistant, it'll probably show up here: " .. tostring(name))
		return
	end
	local num = utility.cmdlist.num + 1
	utility.cmdlist.name[num] = name
	utility.cmdlist.helptext[num] = helptext
	utility.cmdlist.flags[num] = flags
	COM_AddCommand(name, func, tonumber(flags))
	utility.cmdlist.num = $1 + 1
end

utility.AddUtilVar = function(name, helptext, default, flags, limits, func)
	-- Allow help for each variable too.
	local num = utility.varlist.num + 1
	utility.varlist.name[num] = name
	utility.varlist.helptext[num] = helptext
	utility.varlist.flags[num] = flags
	utility.varlist.num = $1 + 1
	return CV_RegisterVar({name, tostring(default), tonumber(flags), limits})
end

--Scans the nodes to get the node number of a player.
utility.PlayerToNode = function(player)
	for x = 0, 31 do
		if players[x] ~= nil
			if players[x] == player
				return x
			end
		end
	end
end

utility.vote = {}
utility.coop = {}
utility.spam = {}
utility.chat = {}
utility.coop["timelimit"] = utility.AddUtilVar("util_coop_exittime", "Sets how many minutes pass until the Co-Op level is completed automatically. Setting it to 0 disables it. Ranges from 0 to 30, default is 0.", "0", CV_NETVAR, {MIN=0, MAX=30})
utility.coop["afktimer"] = utility.AddUtilVar("util_coop_afktimer", "Sets how many seconds pass until a player is considered AFK. Setting it to 0 disables it. Ranges from 0 to 600, default is 120.", "120", CV_NETVAR, {MIN=0, MAX=1200})
utility.vote["votetime"] = utility.AddUtilVar("util_vote_time", "Changes how many seconds are on the timer when a vote takes place. Ranges from 10 to 300, default is 30.", "30", CV_NETVAR, {MIN=10, MAX=300})
utility.vote["votedelay"] = utility.AddUtilVar("util_vote_delay", "Changes how many seconds until a user can call a vote again. Ranges from 0 to 61356675, default 300.", "30", CV_NETVAR, {MIN=0, MAX=61356675})
utility.vote["spectatorvote"] = utility.AddUtilVar("util_vote_specvote", "Determines if spectators are allowed to take part in a vote. Either Yes or No, default is Yes.", "Yes", CV_NETVAR, CV_YesNo)
utility.spam["time"] = utility.AddUtilVar("util_spam_time", "The minimum time threshold in which to silence players. This time threshold is checked on every number of messages specified by util_chat_num. Ranges from 0 to 30, default 3. Setting this to 0 disables spam checks.", "3", CV_NETVAR, {MIN=0, MAX=30})
utility.spam["num"] = utility.AddUtilVar("util_spam_num", "The number of messages to be regarded by the time threshold on each iteration. Ranges from 0 to 30, default 5. Setting this to 0 disables spam checks.", "5", CV_NETVAR, {MIN=0, MAX=30})
utility.spam["repeats"] = utility.AddUtilVar("util_spam_repeats", "Decides whether repeated messages should be allowed. Either Yes or No, default is No.", "No", CV_NETVAR, CV_YesNo)
utility.chat["filter"] = utility.AddUtilVar("util_chat_filter", "Decides if chat should be filtered of swear words. Either Off, On, or CLR. CLR is exhaustive and might slow down the game a bit. Default is Off.", "Off", CV_NETVAR, {Off = 0, On = 1, CLR = 2})
utility.chat["macro"] = utility.AddUtilVar("util_chat_macro", "Decides whether chat macros should be allowed to be used. Either Yes or No, default is Yes.", "Yes", CV_NETVAR, CV_YesNo)
utility.chat["slow"] = utility.AddUtilVar("util_chat_slow", "Allows throttling of messages. Setting this to a non-zero value will allow a message to only be sent when the timer runs out. Admins bypass this limit. Value is in seconds. Ranges from 0 to 30, default 0.", "0", CV_NETVAR, {MIN=0, MAX=30})

--Unused, but you may use it if you wish.
utility.GetChar = function(str, num)
	return string.sub(str, num, num)
end

--Takes a permission node and breaks it down into its elementary steps.
--This is unused in the current script, but you may use it if you want an alternative to purge string checks.
utility.ParsePermissionNode = function(perm)
	assert(perm ~= nil, "utility.parsePermissionNose() requires a string input.")
	assert(type(perm) ~= "string", "utility.parsePermissionNose requires a string input.")
	local hierarchy = {}
	local g = 1
	local s = 1
	local n = 0
	while true do
		s = string.find(perm, ".")
		if s == nil
			hierarchy[g] = string.sub(perm, n+1, string.len(perm))
			break
		end
		hierarchy[g] = string.sub(perm, n+1, s-1)
		g = $1 + 1
		n = s
	end
end

--Takes an array input and shoves out a true or false.
utility.CheckPermList = function(need, permset)
	--print("\x82" .. "Perms - We need: " .. need)
	for a=1,#permset do
		--print("Perms * We saw: " .. string.lower(permset[a]))
		local star = string.find(permset[a], "*")
		if star == nil --Doesn't have a wildcard star. Try to match 1 to 1.
			if string.lower(need) == string.lower(permset[a])
				--print("\x82" .. "Perms - Check success.")
				return true --Matches exact permission.
			end
		else --Has a wildcard star. Check from the beginning to see if it at least contains everything before the star.
			local prevtext = string.sub(permset[a], 1, star-1)
			--print("\x85" .. "Perms # prevtext is " .. tostring(prevtext))
			local starcheck = string.find(need, prevtext)
			--print("\x85" .. "Perms # starcheck is " .. tostring(starcheck))
			if starcheck ~= nil
			and starcheck == 1
				--print("\x82" .. "Perms - Check success.")
				return true --Matches star check.
			end
		end
	end
	--print("\x82" .. "Perms - Check failure.")
	return false
end

--Permission node checker.
utility.HasPerms = function(p, needperm, adminoverride, nomsg)
	if type(p) ~= "userdata"
	or type(needperm) ~= "string"
	or type(adminoverride) ~= "boolean"
	or type(nomsg) ~= "boolean"
		print("\x82" .. "WARNING" .. "\x80" .. ": Invalid value passed to utility.HasPerms!")
		return false
	end
	if p.name == nil
		print("\x82" .. "WARNING" .. "\x80" .. ": Invalid value passed to utility.HasPerms!")
		return false
	end
	
	--print("A. Begin permission check.")
	if p.utility == nil
		CONS_Printf(p, "Your Utility variables aren't ready yet!.")
		return false
	end
	--print("B. Check if it's the server.")
	if p == server --Server always has permission.
	or splitscreen --Local players share the console.
		return true
	end
	--print("C. Try admin override.")
	if adminoverride ~= nil --Check this to allow operator (@) privilege to this without the use of a permission node.
	and adminoverride == true
		if IsPlayerAdmin(p) == true
			return true
		end
	end
	--print("D. Begin permission node searches.")
	if #p.utility.perm.group > 0 --Check usergroup permissions.
		for r=1,#p.utility.perm.group do
			--print("D. Check group " .. p.utility.perm.group[r] .. ".")
			if utility.CheckPermList(needperm, utility.group[p.utility.perm.group[r]].perms) == true
				return true --You have the permission needed.
			end
		end
	end
	--print("E. Check user-specific permissions.")
	if #p.utility.perm.user > 0 --Check user permissions.
		if utility.CheckPermList(needperm, p.utility.perm.user) == true
			return true --You have the permission needed.
		end
	end
	--print("F. No permission!")
	if nomsg == nil
	or nomsg == false
		CONS_Printf(p, "You don't have permission to use this command/variable.")
	end
	return false --You lack permission!
end

--Permission checker. If true, it will do nothing. If false, it will print to the player that they lack permission. Make nomsg not nil to hide the permission deny message.
--NOTE: This function will be depreciated eventually for the newer permission node system.
utility.IsAdmin = function (p, nomsg)
	assert(true, "\x82" .. "WARNING" .. "\x80" .. ": utility.IsAdmin is depreciated and will be removed. use utility.HasPerms instead.")
	local perm = 0
	local termadmin = false
	if terminal ~= nil
		perm = p.servperm
		if perm ~= nil
			if perm & terminal.permissions.FULLCONTROL
			or perm & terminal.permissions.PLAYERMANAGE
				termadmin = true
			end
		end
	end
	if p == server
	or IsPlayerAdmin(p) == true
	or termadmin == true
		return true
	else
		if nomsg == nil
			CONS_Printf(p, "You don't have permission to use this Utility command/variable.")
		end
		return false
	end
end

local function getSymbol(player) --Supprots Terminal and 2.1.21 multi-admin.
	--Permcolor is a local funtion and not in the global namespace, so I added my own color hierarchy.
	if player == server then return "\x81" .. "~" end -- Server
	local p = player.servperm
	if terminal.permissions.text.L0 ~= nil --Alyssa's weird L0 permission
		if p == 1 then return "" end
	end
	if not p then return "" end -- No permissions! D:
	if IsPlayerAdmin(player) == true then return "\x86" .. "*" end -- Vanilla Operator
	if (p & terminal.permissions.FULLCONTROL) then return "\x85" .. "&" end -- Admin
	if (p & terminal.permissions.PLAYERMANAGE) then return "\x83" .. "@" end -- Operator
	if (p & terminal.permissions.GAMEMANAGE) then return "\x80" .. "%" end -- Half-Op
	if (p & terminal.permissions.GLOBALCHEATS) then return "\x87" .. "#" end -- Cheater+
	if (p == terminal.permissions.GLOBALCHEATS) then return "\x87" .. "#" end -- Cheater+
	if (p & terminal.permissions.SELFCHEATS) then return "\x84" .. "+" end -- Cheater
	return ""
end

utility.RandChar = function (chars)
	if type(chars) ~= "number"
		print("The RandChar function was given a non-numberical value.")
	else
		local charset = "abcdefghijklmnopqrstuvwzyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
		if chars < 1
		or chars > 128
			return ""
		else
			local str = ""
			for q=1,chars do
				str = str .. utility.GetChar(charset, P_RandomRange(1,string.len(charset)))
			end
			return str
		end
	end
end

utility.ExtendedTeam = function (player)
	if player.mo == nil
		return 0
	else
		if player.spectator == 1
			return 0
		end
		if gametype == GT_TAG
		or gametype == GT_HIDEANDSEEK
			if player.pflags & PF_TAGIT
				return 5
			else
				return 4
			end
		elseif gametype == GT_TEAMMATCH
		or gametype == GT_CTF
			if player.ctfteam == 1
				return 2
			elseif player.ctfteam == 2
				return 3
			else
				return 1
			end
		end
		return 1
	end
end

utility.Insignia = function(player)
	if terminal ~= nil --Let's use their symbols.
		return getSymbol(player)
	else
		if player == server
			return "\x81" .. "~" .. "\x80"
		elseif IsPlayerAdmin(player)
			return "\x87" .. "@" .. "\x80"
		else
			return ""
		end
	end
end

utility.TeamedName = function(player) --Converts a player's name to a symbol-marked team-colored name.
	local name = player.name
	if player == server
		if server.isdedicated == true --Use the dedicated server name.
			name = dedicatedname
		end
	end
	return utility.Insignia(player) .. string.format(utility.msg.teamcolor[utility.ExtendedTeam(player)], name)
end

utility.BestGroup = function(p)
	local bestpriority = 0
	local bestgroup = "default"
	if #p.utility.perm.group == 0
		print("Player " .. p.name .. " has no usergroups! This should never happen! Report this immediately! In the meantime, Utility will auto-fix this for you.")
		p.utility.perm.group = {"default"}
	else
		for g=1,#p.utility.perm.group do
			local yourpri = utility.group[p.utility.perm.group[g]].priority
			if yourpri > bestpriority
				bestpriority = yourpri
				bestgroup = p.utility.perm.group[g]
			elseif yourpri == bestpriority
				if p.utility.perm.group[g] >= bestgroup
					bestgroup = p.utility.perm.group[g]
				end
			end
		end
	end
	return bestpriority, bestgroup
end

utility.GroupName = function(p) --Creates the group name for a player in chat.
	--local highestgroup --Calculates the highest group for a user and uses that title.
	--local highpriority = -9001 --If you're willing to set your group priorities to this, I'm going to start questioning YOUR priorities.
	local mypriority, mygroup = utility.BestGroup(p)
	local name = p.name
	if string.len(utility.group[mygroup].title) > 0 --Actually is a legitimate string.
		return "\x80" .. "[" .. utility.group[mygroup].color .. utility.group[mygroup].title .. "\x80" .. "]"
	else
		return "" --There is no prefix!
	end
end

utility.ConsoleTell = function(msg)
	for plr in players.iterate do
		if utility.HasPerms(plr, "utility.msg.console", true, true)
			CONS_Printf(plr, "\x86" .. "[CONSOLE]: " .. msg)
		end
	end
	if server.isdedicated
		CONS_Printf(server, "\x86" .. "[CONSOLE]: " .. msg)
	end
end

utility.PermissionTell = function(p, msg)
	if utility.HasPerms(p, "utility.msg.perms", true, true)
		CONS_Printf(p, msg)
	end
end

--Credits: Terminal Team
local function passwordHash(original)
	local hash = 4096
	for i=1,original:len() do
		local number = original:byte(i)
		hash = $1+number
		hash = $1*300
		hash = $1*$1
		hash = $1^^6983745
	end
	if hash < 0 then
		hash = $1-(1<<31)
	end
	hash = ($1>>8)+($1%256)*32154
	return hash
end

--Avast ye server hosts! This is one of the most abusable commands for voting. If you really want to stay in the same game mode, I suggest you keep this set to disabled.
local function Cmd_Gametype(p, gamemode) --Allows live changing of the gametype! This will take you to the first available map of that gametype.
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.legacy.gametype", true, false) == false then return end
	if multiplayer == true
		if gamemode == nil
			CONS_Printf(p, "Gametype is \"" .. utility.gametype.names[gametype] .. "\" (" .. tostring(gametype) .. ")")
		else
			if p == server
			or IsPlayerAdmin(p) == true
			or splitscreen == true
				local leveltype = -1
				local wantedmap = -1
				if tonumber(gamemode) ~= nil
					if tonumber(gamemode) > 0
					and tonumber(gamemode) < 8
						leveltype = tonumber(gamemode)
					end
				else
					for a=0,7 do
						if utility.gametype.names[a] == string.lower(gamemode)
							leveltype = a
							break
						end
					end
				end
				if leveltype ~= -1
					local tol = utility.gametype.tol[leveltype]
					for b=1,1035 do
						if mapheaderinfo[b] ~= nil
							if mapheaderinfo[b].typeoflevel & tol
								wantedmap = b
								break
							end
						end
					end
					if wantedmap == -1
						CONS_Printf(p, "No maps for this gametype! Toto, we're not in Kansas anymore...") --HOW?!?
					else
						COM_BufInsertText(server, "map " .. G_BuildMapName(wantedmap) .. " -gametype " .. tostring(leveltype))
						utility.ConsoleTell(utility.TeamedName(p) .. "\x86" .. " changed the gametype.")
					end
				else
					CONS_Printf(p, "Invalid game mode.")
				end
			else
				CONS_Printf(p, "Gametype is \"" .. utility.gametype.names[gametype] .. "\" (" .. tostring(gametype) .. ")")
			end
		end
	else
		CONS_Printf(p, "This command is exclusive to multiplayer.")
	end
end

--Marks a player as silenced. They will be unable to chat in public or team chats.
local function A_SilencePlayer(adm, victim, seconds, reason)
	if victim ~= nil
		if utility.HasPerms(victim, "utility.msg.override.silence", true, true) == true
			if adm ~= nil
				CONS_Printf(adm, "That player is not silencable.")
			end
			return
		end
		victim.utility.silenced = true
		victim.utility.quiettime = seconds * TICRATE
		local msg = ""
		local name
		if reason ~= nil
			msg = " Reason: " .. reason
		end
		if adm == nil
			name = "\x81" .. "Console" .. "\x80"
		else
			name = utility.TeamedName(adm)
		end
		local setit = ""
		local forgetit = ""
		if victim.utility.quiettime > 0
			setit = "You have silenced "
			forgetit = "You have been silenced for "
		else
			setit = "You undid and silenced "
			forgetit = "Your silence has been updated to "
		end
		if adm ~= nil
			CONS_Printf(adm, setit .. utility.TeamedName(victim) .. " for " .. tostring(seconds) .. " seconds." .. msg)
		end
		chatprintf(victim, forgetit .. tostring(seconds) .. " seconds by " .. name .. "." .. msg)
		utility.ConsoleTell(name .. "\x86" .. " silenced " .. utility.TeamedName(victim) .. "\x86" .. " for " .. tostring(seconds) .. "\x86" .. " seconds." .. msg)
	else
		CONS_Printf(adm, "Player doesn't exist!")
	end
end

--Reverses the other thing.
local function A_UnsilencePlayer(adm, victim)
	if victim ~= nil
		if victim.utility.quiettime == 0
			CONS_Printf(adm, "This player is not silenced.")
			return
		end
		victim.utility.silenced = false
		victim.utility.quiettime = 0
		CONS_Printf(adm, "You unsilenced " .. utility.TeamedName(victim) .. "." )
		CONS_Printf(victim, "You have been unsilenced by " .. utility.TeamedName(adm) .. "." )
		utility.ConsoleTell(utility.TeamedName(adm) .. "\x86" .. " unsilenced " .. utility.TeamedName(victim) .. "\x86" .. ".")
	else
		CONS_Printf(adm, "Player doesn't exist!")
	end
end

--Find the node of a player.
local function F_GetNode(player)
	for a=0,31 do
		if players[a] ~= nil
			if players[a] == player
				return a
			end
		end
	end
end

local function F_FindPlayer(nodename) --Finds a player via node or name on one input. Returns the node number if valid, returns -1 otherwise.
	if nodename == nil
		return -1
	end
	if tonumber(nodename) ~= nil --We have a number.
		if tonumber(nodename) <=31
		and tonumber(nodename) >= 0
			if players[tonumber(nodename)] ~= nil
				if players[tonumber(nodename)].valid
					return tonumber(nodename)
				end
			end
		else
			return -1
		end
	else
		local matchnode = 99
		for a=0,31 do
			if players[a] ~= nil
				if players[a].valid
					if string.lower(players[a].name) == string.lower(nodename)
						matchnode = a
					end
				end
			end
		end
		if matchnode ~= 99
			return matchnode
		end
	end
	return -1
end

utility.votablecmds = {}
utility.votablecmds["name"] = {}
utility.votablecmds["allow"] = {}
utility.votablecmds["logic"] = {}
utility.votablecmds["minvoters"] = utility.AddUtilVar("util_minvoters", "This determines the minimum amount of players required before a vote can occur. Minimum of 1, maximum of 32.", "2", CV_NETVAR, {MIN=1, MAX=32})

--You can use this function below to define your own commands that should be votable by players.
utility.AddVotableCommand = function(name, logic, allowed)
	local num = #utility.votablecmds.name
	if num == nil
		num = 0
	end
	if name == nil
	or logic == nil
		print("Bad call to AddVotableCommand. Review your code and try again.")
	else
		utility.votablecmds.name[num+1] = name
		utility.votablecmds.logic[num+1] = logic
		local allowit = "No"
		if allowed ~= nil
			if allowed == true
				allowit = "Yes"
			end
		end
		utility.votablecmds.allow[num+1] = utility.AddUtilVar("util_votecmd_" .. name, "This is a permission flag that determines whether the specifid command can be queued up via the callvote command. This variable controls the rights to call the command \"" .. name .. "\". Set this to Yes or No.", allowit, CV_NETVAR, CV_YesNo)
	end
end

--Tries to start a vote, and if it can, do it.
local function A_StartVote (starter, command, reason, exec)
	if server.globals.vote.started == true
		CONS_Printf(starter, "Voting could not commence, for there is already one in progress.")
	elseif command == nil
		CONS_Printf(starter, "Please specify a command.")
	else
		server.globals.vote.started = true
		server.globals.vote.time = utility.vote.votetime.value * TICRATE
		server.globals.vote.cmd = command
		server.globals.vote.exec = exec
		server.globals.vote.reason = reason
		server.globals.vote.yes = 0
		server.globals.vote.no = 0
		server.globals.vote.total = 0
		for player in players.iterate
			player.utility.voted = 0
		end
		print("\x82" .. utility.TeamedName(starter) .. " calls a vote \"" .. command .. "\"")
	end
end

--Maps the letters to values to quickly do extended name math.
local mapletters = {"a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"}
local lettervalue1 = {}
local lettervalue2 = {}
for a=1,26 do
	lettervalue1[mapletters[a]] = 100 + ((a-1) * 36)
	lettervalue2[mapletters[a]] = a + 9
end

utility.MapXXAsMapnum = function (str)
	local mapxx = string.gsub(string.lower(str), "map", "")
	local mapnum = 0
	if str == nil
		return -1
	end
	if string.len(mapxx) ~= 2
		return -1
	end
	local first = string.lower(string.sub(mapxx, 1, 1))
	local second = string.lower(string.sub(mapxx, 2, 2))
	if first == nil
	or second == nil
		return -1
	else
		if tonumber(first) == nil --Probably a letter.
			if lettervalue1[first] == nil
				return -1
			end
			mapnum = $1 + lettervalue1[first]
			if tonumber(second) == nil --Probably a letter.
				if lettervalue1[second] == nil
					return -1
				end
				mapnum = $1 + lettervalue2[second]
			else
				mapnum = $1 + tonumber(second)
			end
		else
			if tonumber(mapxx) == nil
				return -1
			else
				mapnum = $1 + tonumber(mapxx)
			end
		end
	end
	return mapnum
end

--Quickly determines the delay between the next vote for the specified player.
local function V_VoteDelay ()
	return (utility.vote.votetime.value + utility.vote.votedelay.value + 5)*TICRATE
end

--Various vote logic.
local function Vote_Kick (p, command, target, reason)
	local node = F_FindPlayer(target)
	if node ~= -1
		A_StartVote(p, "kick \"" .. players[node].name .. "\"", reason, "kick " .. node .. " \"" .. reason .. "\"")
		p.utility.votedelay = 335*TICRATE
	else
		CONS_Printf(p, "Invalid target player.")
	end
end

local function Vote_Exitlevel (p, command, target, reason)
	if target == nil
		target = "No reason given"
	end
	reason = target
	A_StartVote(p, "exitlevel", reason, "exitlevel")
	p.utility.votedelay = V_VoteDelay()
end

local function Vote_Timelimit (p, command, target, reason)
	if reason == nil
		reason = "No reason given"
	end
	if target == nil
		CONS_Printf(p, "You must supply a number of minutes.")
		return
	end
	local number = tonumber(target)
	if number == nil
		number = 0
	end
	if number <= 30
	and number >= 0
		A_StartVote(p, "timelimit " .. tostring(number), reason, "timelimit " .. tostring(number))
		p.utility.votedelay = V_VoteDelay()
	else
		CONS_Printf(p, "Number of minutes should be between 0 and 30")
	end
end

local function Vote_Pointlimit (p, command, target, reason)
	if reason == nil
		reason = "No reason given"
	end
	if target == nil
		CONS_Printf(p, "You must supply a number of points.")
		return
	end
	local number = tonumber(target)
	if number == nil
		number = 0
	end
	if number <= 2147483647
	and number >= 0
		A_StartVote(p, "pointlimit " .. tostring(number), reason, "pointlimit " .. tostring(number))
		p.utility.votedelay = V_VoteDelay()
	else
		CONS_Printf(p, "Number of points should be between 0 and 2147483647")
	end
end

local function Vote_Map (p, command, target, reason)
	if reason == nil
		reason = "No reason given"
	end
	if target == nil
		CONS_Printf(p, "You must supply a map to go to in the form of MAPxx")
		return
	else
		local mapnumber = utility.MapXXAsMapnum(target)
		if mapnumber == -1
			CONS_Printf(p, "Invalid map; Please supply a MAPXX value. This can be the level code (e.g. 03, B1, M3) or a map name (like MAP24)")
		else
			if mapheaderinfo[mapnumber] == nil
				CONS_Printf(p, "Invalid map; That map apparently does not exist.")
			else
				local mapcode = target
				if string.len(target) == 2
					mapcode = "map" .. target
				end
				local act = ""
				if mapheaderinfo[mapnumber].actnum > 0
					act = " " .. tostring(mapheaderinfo[mapnumber].actnum)
				end
				A_StartVote(p, "Go to " .. mapheaderinfo[mapnumber].lvlttl .. act .. " (" .. mapcode .. ")", reason, "map " .. mapcode)
				p.utility.votedelay = V_VoteDelay()
			end
		end
	end
	local number = tonumber(target)
end

local function Vote_Gametype (p, command, target, reason)
	if reason == nil
		reason = "No reason given"
	end
	if target == nil
		CONS_Printf(p, "You must supply a gametype to play.")
		return
	end
	local number = -1
	if tonumber(target) == nil
		for a=0,7 do
			if utility.gametype.names[a] == string.lower(target)
				number = a
				break
			end
		end
	else
		number = tonumber(trget)
	end
	if number >= 0
	and number <= 7
		A_StartVote(p, "gametype \"" .. utility.gametype.names[number] .. "\"", reason, "gametype " .. target)
		p.utility.votedelay = V_VoteDelay()
	else
		CONS_Printf(p, "Please specify a valid gametype. Gametypes: 0/coop, 1/competition, 2/race, 3/match, 4/teammatch, 5/tag, 6/hideandseek, 7/ctf")
	end
end

--Putting the votes into the table with the function.
utility.AddVotableCommand("kick", Vote_Kick, false)
utility.AddVotableCommand("exitlevel", Vote_Exitlevel, true)
utility.AddVotableCommand("timelimit", Vote_Timelimit, true)
utility.AddVotableCommand("pointlimit", Vote_Pointlimit, true)
utility.AddVotableCommand("map", Vote_Map, true)
utility.AddVotableCommand("gametype", Vote_Gametype, false)

--Democracy!
local function Cmd_Vote(p, response)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.vote.vote", true, false) == false then return end
	if p.mo == nil
		if p.jointime == 0
			CONS_Printf(p, "You need be in-game to vote. If you're the dedicated server, you can stop a vote with the cancelvote command.")
			return
		else
			if p.spectator == true
			and utility.vote.spectatorvote.value == 0
				CONS_Printf(p, "The server does not allow spectators to vote.")
				return
			end
		end
	end
	if response == nil
		CONS_Printf(p, "Usage: vote <yes/no>")
		return
	end
	if splitscreen
		CONS_Printf(p, "This command is redundant in splitscreen play.")
	elseif not multiplayer
		CONS_Printf(p, "This command is only usable in multiplayer.")
	elseif server.globals.vote.started == false
	or server.globals.vote.result ~= "none"
		CONS_Printf(p, "Nobody is calling a vote right now.")
	else
		if p.utility.voted == 0
			if string.lower(response) == "yes"
				p.utility.voted = 1
				server.globals.vote.yes = $1 + 1
				server.globals.vote.total = $1 + 1
				print("\x82" .. p.name .. " votes \"" .. "\x83" .. "YES".. "\x82" .. "\".")
			elseif string.lower(response) == "no"
				p.utility.voted = 2
				server.globals.vote.no = $1 + 1
				server.globals.vote.total = $1 + 1
				print("\x82" .. p.name .. " votes '" .. "\x85" .. "NO".. "\x82" .. "'.")
			else
				CONS_Printf(p, "Use 'yes' or 'no'.")
			end
		else
			CONS_Printf(p, "You have already voted.")
		end
	end
end

--Anarchy!
local function Cmd_Cancelvote (p)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.vote.cancel", true, false) == false then return end
	if splitscreen
		CONS_Printf(p, "This command is redundant in splitscreen play.")
	end
	if multiplayer
		if server.globals.vote.started == true
			server.globals.vote.time = 0
			server.globals.vote.yes = 0
			server.globals.vote.no = 0
			server.globals.vote.total = 0
			print("\x82" .. utility.TeamedName(p) .. " forcibly cancelled the vote.")
		else
			CONS_Printf(p, "No vote in progress.")
		end
	else
		CONS_Printf(p, "This command is only usable in multiplayer.")
	end
end

--Made for ease of use (And because the Dedicated Server cannot type underscores)
local function Cmd_Votepermission (p, cmd, value)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.vote.permission", true, false) == false then return end
	if cmd == nil
		CONS_Printf(p, "Please supply a command. votepermission <command> <allow/deny>")
		CONS_Printf(p, "You may use a numerical ID or the command name. Try showvotecmds for a list.")
		return
	else
		local command = string.lower(cmd)
		local cmdnum = 0
		local loopnum = #utility.votablecmds.name
		if loopnum == nil
			CONS_Printf(p, "You must have a votable command before you decide permissions.")
		end
		if tonumber(command) ~= nil
			cmdnum = tonumber(command)
		else
			for x=1,loopnum
				if utility.votablecmds.name[x] == command
					cmdnum = x
					break
				end
			end
		end
		if utility.votablecmds.name[cmdnum] == nil --Doesn't exist.
			cmdnum = 0
		end
		if cmdnum ~= 0
			if value == nil
				value = "nothing"
			end
			if string.lower(value) == "allow"
				if utility.votablecmds.allow[cmdnum].value == 1
					CONS_Printf(p, "Vote permission for command \"" .. utility.votablecmds.name[cmdnum] .. "\" is already set to " .. "\x83" .. "ALLOW" .. "\x80" .. ". Value unchanged.")
				else
					print("Vote permission for command \"" .. utility.votablecmds.name[cmdnum] .. "\" was set to " .. "\x83" .. "ALLOW" .. "\x80" .. ".")
					COM_BufInsertText(server, "util_votecmd_" .. utility.votablecmds.name[cmdnum] .. " 1")
				end
			elseif string.lower(value) == "deny"
				if utility.votablecmds.allow[cmdnum].value == 0
					CONS_Printf(p, "Vote permission for command \"" .. utility.votablecmds.name[cmdnum] .. "\" is already set to " .. "\x85" .. "DENY" .. "\x80" .. ". Value unchanged.")
				else
					print("Vote permission for command \"" .. utility.votablecmds.name[cmdnum] .. "\" was set to " .. "\x85" .. "DENY" .. "\x80" .. ".")
					COM_BufInsertText(server, "util_votecmd_" .. utility.votablecmds.name[cmdnum] .. " 0")
				end
			else
				if utility.votablecmds.allow[cmdnum].value == 1
					CONS_Printf(p, "Vote permission for command \"" .. utility.votablecmds.name[cmdnum] .. "\" is currently set to " .. "\x83" .. "ALLOW" .. "\x80" .. ".")
				elseif utility.votablecmds.allow[cmdnum].value == 0
					CONS_Printf(p, "Vote permission for command \"" .. utility.votablecmds.name[cmdnum] .. "\" is currently set to " .. "\x85" .. "DENY" .. "\x80" .. ".")
				else
					CONS_Printf(p, "Vote permission for command \"" .. utility.votablecmds.name[cmdnum] .. "\" is currently set to " .. "\x82" .. "AMBIGUOUS" .. "\x80" .. ". This is probably an issue.")
				end
			end
		else
			CONS_Printf(p, "This is not a valid votable command.")
		end
	end
end

--Let's become a permanent deadweight!
utility.BecomeAFK = function(player)
	if player.mo == nil
		CONS_Printf(player, "You need to be an actual in-game player.")
	else
		if player.utility.afk == false
			if player.utility.afkdelay == 0
			or splitscreen
				if player.bonustime == true
					CONS_Printf(player, "You cannot AFK right now. Finish the NiGHTS Stage.")
				else
					player.utility.afk = true
					player.utility.afkdelay = 30 * TICRATE --Can't do this again for a while.
					if player.exiting == 0
						player.exiting = 1
					end
					player.utility.lock.x = player.mo.x
					player.utility.lock.y = player.mo.y
					player.utility.lock.z = player.mo.z
					player.utility.lock.momx = player.mo.momx
					player.utility.lock.momy = player.mo.momy
					player.utility.lock.momz = player.mo.momz
					print(utility.TeamedName(player) .. " is now AFK.")
				end
			else
				CONS_Printf(player, "You must wait " .. tostring(player.utility.afkdelay / TICRATE) .. " seconds before going AFK again.")
			end
		elseif player.utility.afk == true
			player.utility.afk = false
			--if (player.mo.subsector.sector.special / 4096) ~= 2 --NOTE: Please change this to a map-based one-time toggle and don't trust the map or user input on this.
			if player.utility ~= nil
				if player.utility.levelcomplete == false
					player.exiting = 0
				end
			else
				player.exiting = 0
			end
			--end
			player.mo.flags2 = $ & !MF2_SHADOW
			print(utility.TeamedName(player) .. " is no longer AFK.")
		end
	end
end

utility.TotalVoters = function ()
	local numplayers = 0
	for player in players.iterate
		if player.mo ~= nil
			numplayers = $1 + 1
		end
		if utility.vote.spectatorvote.value == 1
			if player.spectator == true
				numplayers = $1 + 1
			end
		end
	end
	return numplayers
end

--Calculates the votes and tells the game to stop the vote immediately if a winning vote percentage has been reached.
--Yes must have MORE than 50% to win. No only needs AT LEAST HALF to win.
local function Vote_IsVoteDone(numplayers)
	local neededyes = (numplayers / 2) + 1
	local neededno = (numplayers+1) / 2
	if numplayers == 1
		neededyes = 1
		neededno = 1
	end
	if server.globals.vote.no >= neededno
		return 1
	elseif server.globals.vote.yes >= neededyes
		return 2
	elseif server.globals.vote.total >= numplayers
		return 3
	else
		return 0
	end
end

local function Cmd_Showvotecmds (p)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.vote.list", true, false) == false then return end
	local num = #utility.votablecmds.name
	if num == nil
		CONS_Printf(p, "No votable commands in the list.")
		return
	else
		CONS_Printf(p, "Votable commands:")
		local starred = " "
		for x=1,num
			if utility.votablecmds.allow[x].value == 1
				starred = " " .. "\x82" .. "*" .. "\x80" .. " "
			else
				starred = "   "
			end
			CONS_Printf(p, " " .. tostring(x) .. ":" .. starred .. utility.votablecmds.name[x])
		end
		CONS_Printf(p, "A " .. "\x82" .. "*" .. "\x80" .. " represents a command votable by all players.")
	end
end

local function Cmd_Callvote (p, command, target, reason)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.vote.start", true, false) == false then return end
	local numvoters = utility.TotalVoters()
	if numvoters == 0
		CONS_Printf(p, "Nobody is around for the vote. Try again later.")
		return
	end
	if utility.HasPerms(p, "utility.cmd.vote.override", true, true) == false --You can call a vote anyway if you're an admin.
		if p.spectator == true
		and utility.vote.spectatorvote.value == 0
			CONS_Printf(p, "The server does not allow spectators to call a vote.")
			return
		end
		if numvoters < utility.votablecmds.minvoters.value
			CONS_Printf(p, "The server requires at least " .. tostring(utility.votablecmds.minvoters.value) .. " players to start a vote.")
			return
		end
	end
	if command == nil
		CONS_Printf(p, "Usage: callvote <command> <variable> [reason]")
		CONS_Printf(p, "Calls a vote. The reason is optional.")
		return
	end
	if reason == nil
		reason = "No reason given"
	end
	if splitscreen
		CONS_Printf(p, "This command is redundant in splitscreen play.")
	elseif not multiplayer
		CONS_Printf(p, "This command is only usable in multiplayer.")
	else
		if p.utility.votedelay < 1
		or IsPlayerAdmin(p) == true
		or p == server
			local cmd = string.lower(command)
			local num = #utility.votablecmds.name
			if num == nil
				print("This server has no votable commands. At all. Hah, is this a joke?")
				return
			end
			for x=1,num
				if utility.votablecmds.name[x] == cmd
					if utility.votablecmds.allow[x].value == 1
					or IsPlayerAdmin(p) == true
					or p == server
						utility.votablecmds.logic[x](p, command, target, reason)
					else
						CONS_Printf(p, "The server/admin has disabled this command from vote calling.")
					end
					return
				end
			end
			CONS_Printf(p, "This isn't a votable command.")
		else
			CONS_Printf(p, "You can call a vote after " .. tostring(p.utility.votedelay / TICRATE) .. " seconds.")
		end
	end
end

local function Cmd_Afk (p)
	if p.utility == nil then return end
	if gametype == GT_COOP
		utility.BecomeAFK(p)
	else
		CONS_Printf(p, "Only usable in Co-Op. Sorry!")
	end
end

local function Cmd_Afk2 (p)
	if splitscreen
		Cmd_Afk(players[1])
	else
		CONS_Printf(p, "This is meant for splitscreen play.")
	end
end

local function Cmd_Afk3 (p)
	if splitscreen
		Cmd_Afk(players[2])
	else
		CONS_Printf(p, "This is meant for splitscreen play.")
	end
end

local function Cmd_Afk4 (p)
	if splitscreen
		Cmd_Afk(players[3])
	else
		CONS_Printf(p, "This is meant for splitscreen play.")
	end
end

local function Cmd_Silence (p, node, seconds, reason)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.silence", true, false) == false then return end 	
	if splitscreen
		CONS_Printf(p, "This command is redundant in splitscreen play.")
	elseif not multiplayer
		CONS_Printf(p, "This command is only usable in multiplayer.")
	else
		local newseconds = 0
		if tonumber(seconds) == nil
			newseconds = 60
		else
			newseconds = tonumber(seconds)
		end
		if newseconds < 5
		and newseconds > 61356675 --Any higher and we will wrap! Do not want.
			newseconds = 60
		end
		if F_FindPlayer(node) >= 0
			A_SilencePlayer(p, players[F_FindPlayer(node)], newseconds, reason)
		else
			CONS_Printf(p, "That player does not exist.")
		end
	end
end

local function Cmd_Unsilence (p, node)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.silence", true, false) == false then return end 	
	if splitscreen
		CONS_Printf(p, "This command is redundant in splitscreen play.")
	elseif not multiplayer
		CONS_Printf(p, "This command is only usable in multiplayer.")
	else
		if F_FindPlayer(node) >= 0
			A_UnsilencePlayer(p, players[F_FindPlayer(node)])
		else
			CONS_Printf(p, "That player does not exist.")
		end
	end
end

local function Cmd_Ignore (p, node)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.ignore", true, false) == false then return end 	
	if splitscreen
		CONS_Printf(p, "This command is redundant in splitscreen play.")
	elseif not multiplayer
		CONS_Printf(p, "This command is only usable in multiplayer.")
	elseif F_FindPlayer(node) == -1
		CONS_Printf(p, "That player does not exist.")
	elseif players[F_FindPlayer(node)] == p
		CONS_Printf(p, "You cannot ignore yourself.")
	else
		if F_FindPlayer(node) >= 0
			p.utility.ignore[F_FindPlayer(node)] = true
			CONS_Printf(p, "Now ignoring node " .. tostring(F_FindPlayer(node)) .. ".")
		end
	end
end

local function Cmd_Unignore (p, node)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.ignore", true, false) == false then return end 	
	if splitscreen
		CONS_Printf(p, "This command is redundant in splitscreen play.")
	elseif not multiplayer
		CONS_Printf(p, "This command is only usable in multiplayer.")
	elseif F_FindPlayer(node) == -1
		CONS_Printf(p, "That player does not exist..")
	else
		if F_FindPlayer(node) >= 0
			p.utility.ignore[F_FindPlayer(node)] = false
			CONS_Printf(p, "Not ignoring node " .. tostring(F_FindPlayer(node)) .. " anymore.")
		end
	end
end

--Change the music for everyone in the server.
local function Cmd_Changemus (p, str)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.changemus", true, false) == false then return end 	
	if str == nil then return end
	for play in players.iterate
		COM_BufInsertText(play, "tunes " .. str)
	end
	print("Music changed to " .. str .. " by " .. utility.TeamedName(p) .. ".")
end

--Change the sky for everyone in the server.
local function Cmd_Changesky (p, str)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.changesky", true, false) == false then return end 	
	if str == nil then return end
	if tonumber(str) == nil
		CONS_Printf(p, "Supply a sky number.")
		return
	end
	P_SetupLevelSky(tonumber(str))
	print("Sky changed to " .. str .. " by " .. utility.TeamedName(p) .. ".")
end

--Refreshes the Notice board if there is none left to be displayed.
local function F_RestartNotice()
	server.globals.notice.num = 0
	server.globals.notice.msg = {[0] = "None"}
	server.globals.notice.duration = {[0] = 0}
	server.globals.notice.delay = {[0] = 0}
	server.globals.notice.color = {[0] = 0}
	server.globals.notice.current = 0
end

--Post a notice. Color currently unused.
utility.AddNotice = function(p, message, seconds, delay, color)
	local num = server.globals.notice.num + 1
	server.globals.notice.msg[num] = message
	server.globals.notice.duration[num] = seconds*TICRATE + delay*TICRATE
	server.globals.notice.delay[num] = seconds*TICRATE
	server.globals.notice.color[num] = color
	server.globals.notice.num = num
	CONS_Printf(p, "Put notice #" .. tostring(server.globals.notice.num) .. " into the Noticeboard queue.")
end

local function F_Concatenate (p, nilmsg, ...)
	local str = ""
	if ... == nil
		CONS_Printf(p, nilmsg)
		return
	else
		local words = {...}
		for a=1,#words do
			if a == #words
				str = $1 .. words[a]
			else
				str = $1 .. words[a] .. " "
			end
		end
	end
	if str == ""
		CONS_Printf(p, nilmsg)
	end
	return str
end

local function Cmd_SayAdmin (p, ...)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.msg.admin", true, false) == false then return end 	
	local message = F_Concatenate(p, "sayadmin <message>: send a message to all other admins", ...)
	if message == nil then return end
	utility.NewMsg(p, 4, nil, message) --Send an admin message.
end

--Sends a notice to the noticeboard. Much more featured than csay.
local function Cmd_Notice (p, seconds, message, delay)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.notice", true, false) == false then return end
	if seconds == nil
	or message == nil
		CONS_Printf(p, "Syntax: notice <seconds> <message> [delay]")
		return
	else
		if tonumber(seconds) == nil
			CONS_Printf(p, "Syntax: notice <seconds> <message> [delay]")
			return
		end
	end
	local sec = tonumber(seconds)
	local wait = tonumber(delay)
	if wait == nil
		wait = 0
	end
	local msg = "= " .. utility.TeamedName(p) .. " says =\n" .. string.gsub(message, "\\", "\n")
	if sec == 0
		if utility.HasPerms(p, "utility.cmd.notice.clear", true, false) == false then return end
		F_RestartNotice()
		print(utility.TeamedName(p) .. " reset the notice queue with reason \"" .. message .. "\"")
	else
		if sec > 60
		or sec < 0
			CONS_Printf(p, "Please use a time between 1-60 seconds. This is to avoid notice-hogging. 0 resets the notice queue.")
			return
		else
			if wait > 60
			or wait < 0
				CONS_Printf(p, "Please use a delay between 1-60 seconds. This is to avoid notice-hogging. 0 resets the notice queue.")
				return
			else
				utility.AddNotice(p, msg, sec, wait, 0)
			end
		end
	end
end

--Legacy command replacement for csay.
local function Cmd_Csay (p, ...)
	if utility.HasPerms(p, "utility.legacy.csay", true, false) == false then return end
	local message = F_Concatenate(p, "csay <message>: Display a 5-second annoyance text.", ...)
	if message ~= nil
		Cmd_Notice(p, 5, message, 0)
	end
end

--Lists commands and variables in Utility
local function Cmd_Util (p, cmd)
	if utility.HasPerms(p, "utility.cmd.util", true, false) == false then return end
	local val = ""
	if cmd == nil
		val = "no_command"
	else
		if string.lower(cmd) == "short"
			val = "short"
		else
			val = cmd
		end
	end
	if val ~= "no_command"
	and val ~= "short"
		local text = string.lower(val)
		for a=1,utility.cmdlist.num do
			if val == utility.cmdlist.name[a]
				CONS_Printf(p, "Help for command \"" .. val .. "\":")
				CONS_Printf(p, utility.cmdlist.helptext[a])
				return
			end
		end
		for b=1,utility.varlist.num do
			if val == utility.varlist.name[b]
				CONS_Printf(p, "Help for variable \"" .. val .. "\":")
				CONS_Printf(p, utility.varlist.helptext[b])
				return
			end
		end
		CONS_Printf(p, "Couldn't find that command/variable. Try typing \"util\" in the console for a list, or \"util short\" for a shortform list.")
	else
		local list = " :"
		CONS_Printf(p, "\x82" .. "List of Utility commands:")
		for a=1,utility.cmdlist.num do
			if val == "short"
				list = $1 .. " " .. utility.cmdlist.name[a]
			else
				CONS_Printf(p, " " .. tostring(a) .. ": " .. utility.cmdlist.name[a])
			end
		end
		if val == "short"
			CONS_Printf(p, list)
		end
		list = " :"
		CONS_Printf(p, "\x82" .. "List of Utility variables:")
		for b=1,utility.varlist.num do
			if val == "short"
				list = $1 .. " " .. utility.varlist.name[b]
			else
				CONS_Printf(p, " " .. tostring(b) .. ": " .. utility.varlist.name[b])
			end
		end
		if val == "short"
			CONS_Printf(p, list)
		end
		CONS_Printf(p, "\x82" .. "For more information about a command or variable, use \"util <command/variable>\" to show its help text.")
	end
end

--Returns the version.
local function Cmd_Utilversion (p)
	CONS_Printf(p, "Version" .. utility.version .. "(Iteration" .. utility.iteration .. ")")
	if utility.subversion == true
		CONS_Printf(p, "\x83" .. "This is a sub-version. (Not an MB release)")
	end
end

local function F_ResetVote ()
	server.globals.vote.time = -3500
	server.globals.vote.cmd = "Nothing"
	server.globals.vote.exec = "english"
	server.globals.vote.yes = 0
	server.globals.vote.no = 0
	server.globals.vote.total = 0
	server.globals.vote.reason = "None."
	server.globals.vote.started = false
	server.globals.vote.result = "none"
end

addHook("MapChange", function (mapnum)
	if server.globals ~= nil
		if server.globals.vote.cmd == "exitlevel"
		or string.lower(string.sub(server.globals.vote.cmd, 1, 3)) == "map"
			F_ResetVote() --End a map vote or exitlevel vote early if the map gets changed.
		end
		for player in players.iterate
			if player.utility ~= nil
				player.utility.levelcomplete = false
			end
		end
	end
	if gametype ~= GT_COOP --Do a sweep to see who is AFK.
		for p in players.iterate do
			if p.utility.afk == true
				p.utility.afk = false
				CONS_Printf(p, "The game mode is no longer Co-Op, so your AFK has been disabled.")
			end
		end
	end
end)

--Ironically this means the dedicated server can have colored names where regular players cannot.
local function Cmd_Dediname (p, ...)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.dedicated.dediname", true, false) == false then return end
	if server.isdedicated == false
		CONS_Printf(p, "This is only usable if the server is dedicated.")
	elseif server.isdedicated == true
		local newname = F_Concatenate(p, "dediname <name>: Name yourself as the dedicated server!", ...)
		local oldname = dedicatedname
		if string.lower(dedicatedname) ~= string.sub(string.lower(newname), 1, 23)
			print(dedicatedname .. " renamed to " .. newname)
			dedicatedname = string.sub(newname, 1, 23)
			server.name = newname
		end
	end
end

--A helper for the ammo macro. Speaking of macros...
utility.weapontoname = {
	[0] = "Ringslinger",
	[WEP_AUTO] = "Automatic",
	[WEP_BOUNCE] = "Bounce",
	[WEP_SCATTER] = "Scatter",
	[WEP_GRENADE] = "Grenade",
	[WEP_EXPLODE] = "Explosion",
	[WEP_RAIL] = "Rail"
}

utility.macrotable = {}
utility.macrotable["match"] = {}
utility.macrotable["logic"] = {}
utility.macrotable["sample"] = {}
utility.macrotable["num"] = 0

--This is chat macro! It will take strings for you and turn them into something else based on conditions and logic. You can add your own with this function.
utility.AddChatMacro = function(matchtext, logic, sample)
	local num = utility.macrotable.num
	utility.macrotable.match[num+1] = matchtext
	utility.macrotable.logic[num+1] = logic
	utility.macrotable.sample[num+1] = false
	if sample ~= nil
		if sample == true
			utility.macrotable.sample[num+1] = true
		end
	end
	utility.macrotable.num = $1 + 1
	print("Added chat macro \"" .. matchtext .. "\" as ID " .. tostring(num+1) .. ".")
end

local function CM_White (player)
	return "\x80"
end

local function CM_Purple (player)
	return "\x81"
end

local function CM_Yellow (player)
	return "\x82"
end

local function CM_Green (player)
	return "\x83"
end

local function CM_Blue (player)
	return "\x84"
end

local function CM_Red (player)
	return "\x85"
end

local function CM_Grey (player)
	return "\x86"
end

local function CM_Orange (player)
	return "\x87"
end

--Bunch of macros to replace common game metrics.
local function CM_Rings (player)
	if player.health < 1
		return "0"
	else
		return tostring(player.health - 1)
	end
end

local function CM_Health (player)
	return tostring(player.health)
end

local function CM_Lives (player)
	return tostring(player.lives)
end

local function CM_Random (player)
	return tostring(P_RandomRange(1,100))
end

local function CM_Location (player)
	if player.mo == nil
		return "Ethereal Plane"
	end
	return "X:" .. tostring(player.mo.x/FRACUNIT) .. " Y:" .. tostring(player.mo.y/FRACUNIT) .. " Z:" .. tostring(player.mo.x/FRACUNIT)
end

local function CM_Score (player)
	return tostring(player.score)
end

local function CM_Time (player)
	local centi = tostring(G_TicsToCentiseconds(player.realtime))
	local sec = tostring(G_TicsToSeconds(player.realtime))
	if G_TicsToCentiseconds(player.realtime) < 10
		centi = "0" .. tostring(G_TicsToCentiseconds(player.realtime))
	end
	if G_TicsToSeconds(player.realtime) < 10
		sec = "0" .. tostring(G_TicsToSeconds(player.realtime))
	end
	return tostring(G_TicsToMinutes(player.realtime, true)) .. ":" .. sec .. "." .. centi
end

local function CM_Name (player)
	return tostring(player.name)
end

local function CM_Weapon (player)
	if player.currentweapon == 0
	and player.powers[pw_infinityring] > 0
		return "Infinity"
	else
		return utility.weapontoname[player.currentweapon]
	end
end

local function CM_Ammo (player)
	if player.currentweapon == nil
		return "nil"
	end
	if player.currentweapon == 0
		if player.powers[pw_infinityring] > 0
			return tostring(player.powers[pw_infinityring])
		else
			local rings = (player.health - 1)
			if rings < 0
				rings = 0
			end
			return tostring(rings)
		end
	else
		return tostring(player.powers[player.currentweapon + 10])
	end
end

local function CM_Coinflip (player)
	local a = P_RandomRange(0,1)
	if a == 0
		return "Heads"
	else
		return "Tails"
	end
end

local function CM_Random (player)
	return tostring(P_RandomRange(1,100))
end

utility.AddChatMacro("$rings", CM_Rings)
utility.AddChatMacro("$health", CM_Health)
utility.AddChatMacro("$lives", CM_Lives)
utility.AddChatMacro("$location", CM_Location)
utility.AddChatMacro("$score", CM_Score)
utility.AddChatMacro("$time", CM_Time)
utility.AddChatMacro("$name", CM_Name)
utility.AddChatMacro("$weapon", CM_Weapon)
utility.AddChatMacro("$ammo", CM_Ammo)
utility.AddChatMacro("$coin", CM_Coinflip)
utility.AddChatMacro("$roll", CM_Random)
utility.AddChatMacro("|ca", CM_White, true)
utility.AddChatMacro("|cb", CM_Blue, true)
utility.AddChatMacro("|cc", CM_Purple, true)
utility.AddChatMacro("|cd", CM_Red, true)
utility.AddChatMacro("|ce", CM_Yellow, true)
utility.AddChatMacro("|cf", CM_Orange, true)
utility.AddChatMacro("|cg", CM_Green, true)
utility.AddChatMacro("|ch", CM_Grey, true)

utility.ChatMacro = function(player, msg)
	--print(tostring(#utility.macrotable.match))
	if utility.chat.macro.value == 0
		return msg --Disable if the server doesn't like macros for whatever screwed up reason.
	end
	if utility.HasPerms(player, "utility.msg.macro", true, true) == false then return end
	if #utility.macrotable.match == nil --Can't replace without data here.
		return msg
	end
	local msg2 = msg
	local replacement = ""
	for x=1,#utility.macrotable.match
		--print("Old: " .. msg2 .. " | " .. utility.macrotable.match[x] .. " | " .. utility.macrotable.logic[x](player))
		msg2 = string.gsub($1, utility.macrotable.match[x], utility.macrotable.logic[x](player))
		--print("New: " .. msg2)
	end
	return msg2
end

local function Cmd_MacroList (p)
	CONS_Printf(p, "\x82" .. "Chat macros are strings that, when said, will be replaced with a value. Good for binds! <Sample Text> is a placeholder string. It does not appear, and is only there to show an effect.")
	CONS_Printf(p, "\x82" .. "Macro : Example")
	for a=1,utility.macrotable.num do
		local sample = utility.macrotable.logic[a](p)
		if utility.macrotable.sample[a] == true
			sample = $1 .. "<Sample Text>"
		end
		CONS_Printf(p, utility.macrotable.match[a] .. " : " .. sample)
	end
end

local allowedcommands = {"addfile", "runsoc", "map", "pause", "ban", "kick", "motd", "cheats", "serverchangeteam",
	"advancemap", "allowjoin", "inttime", "mute", "pausepermission", "allowexitlevel", "allowseenames", "allowteamchange", "autobalance", "forceskin",
	"friendlyfire", "overtime", "pointlimit", "powerstones", "respawndelay", "respawnitem", "scrambleonchange", "skipmapcheck", "specialrings", "suddendeath",
	"tailspickup", "teamscramble", "timelimit", "countdowntime", "hidetime", "matchscoring", "numlaps", "playersforexit", "startinglives", "touchtag",
	"usemaplaps", "competitionboxes", "flagtime", "matchboxes", "respawnitemtime", "restrictskinchange", "tv_1up", "tv_bombshield", "tv_eggman", "tv_forceshield",
	"tv_invincibility", "tv_jumpshield", "tv_recycler", "tv_ringshield", "tv_superring", "tv_supersneaker", "tv_teleporter", "tv_watershield", "gravity", "killingdead",
	"ringslinger", "soniccd", "exitlevel"
}

utility.vanilla = {}

for x=1,#allowedcommands do
	utility.vanilla[x] = {}
	utility.vanilla[x].cmd = allowedcommands[x]
	utility.vanilla[x].perm = "vanilla.cmd." .. allowedcommands[x]
end

local function Cmd_Vanilla (p, ...)
	if p.utility == nil 
		return
	else
		local commandline = {...}
		if #commandline == 0
			CONS_Printf(p, "Syntax: vanilla <cmd> <parameters> ...")
			return
		end
		local neededperm = ""
		local basecommand = string.lower(commandline[1])
		local arg = commandline[2]
		if basecommand == "kick" --Check for kick and ban overrides.
		or basecommand == "ban"
			if arg ~= nil
				local t = F_FindPlayer(commandline[2])
				local actionperm = "vanilla.cmd." ..  basecommand .. ".override"
				if t == -1
					if tonumber(commandline[2]) == nil
						CONS_Printf(p, "There is no player named \"" .. commandline[2] .."\"")
					end
					return
				else
					local target = players[t]
					local action
					if basecommand == "kick"
						action = "kicked"
					else
						action = "banned"
					end
					if utility.HasPerms(target, actionperm, true, true) == true
						CONS_Printf(p, "This user cannot be " .. action .. " in the vanilla command.")
						return
					end
				end
			end
		end
		local cmdmatch = false
		for x=1,#utility.vanilla do
			if utility.vanilla[x].cmd == basecommand
				cmdmatch = true
				neededperm = utility.vanilla[x].perm
				break
			end
		end
		if cmdmatch == false
			CONS_Printf(p, "This vanilla command is not available.")
		else
			if utility.HasPerms(p, neededperm, true, true) == true
				local fullcommand
				for x=1,#commandline do
					if x==1
						fullcommand = commandline[x]
					else
						fullcommand = fullcommand .. " \"" .. commandline[x] .. "\""
					end
				end
				if string.find(fullcommand, ";") ~= nil
					CONS_Printf(p, "Please do not use the ; special character in the Vanilla command executor.")
					return
				end
				utility.ConsoleTell(utility.TeamedName(p) .. "\x86" .. " executes vanilla command: " .. "\x84" .. fullcommand)
				COM_BufInsertText(server, fullcommand)
			else
				CONS_Printf(p, "You cannot use this Vanilla command.")
			end
			--[[ This is quite obviously ripped from rcon.lua but it works!
			for play in players.iterate do
				if play.rcon == true
				or play == admin
					CONS_Printf(play, "RCon from " .. p.name .. ": " .. "\x84" .. fullcommand)
				end
			end
			--]]
		end
	end
end

utility.CanModifyPriority = function(p, thispriority)
	if p == server return true end
	local mypriority, mygroup = utility.BestGroup(p)
	if mypriority > thispriority then return true end
	return false
end

utility.CanModifyGroup = function(p, thisgroup)
	if p == server return true end
	local mypriority, mygroup = utility.BestGroup(p)
	if utility.group[thisgroup] == nil then return false end
	if mypriority > utility.group[thisgroup].priority then return true end
	return false
end

local function Cmd_Listperms (p, other)
	local t = F_FindPlayer(other)
	local target
	if t == -1
		target = p
	else
		target = players[t]
	end
	if target == p
		if utility.HasPerms(p, "utility.user.listperms", true, false) == false then return end
	else
		if utility.HasPerms(p, "utility.user.listperms.other", true, false) == false then return end
	end
	CONS_Printf(p, "\x87" .. "A list of " .. target.name .. "'s permissions.")
	if p == server
	or IsPlayerAdmin(p) == true
		CONS_Printf(p, "\x81" .. "Special permissions:")
		if p == server
			CONS_Printf(p, "\x85" .. "- Server (Override ALL permissions)")
		end
		if IsPlayerAdmin(p) == true
			CONS_Printf(p, "\x85" .. "- Operator (Override MOST permissions)")
		end
	end
	CONS_Printf(p, "\x82" .. "User permissions:")
	if #target.utility.perm.user > 0
		for n=1,#target.utility.perm.user do
			CONS_Printf(p, "- " .. target.utility.perm.user[n])
		end
	else
		CONS_Printf(p, "\x86" .. "- None given.")
	end
	if #target.utility.perm.group > 0
		for n=1,#target.utility.perm.group do
			local group = target.utility.perm.group[n]
			CONS_Printf(p, "\x83" .. "Inherited from group " .. group .. ":")
			if #utility.group[group].perms > 0
				for g=1,#utility.group[group].perms
					CONS_Printf(p, "- " .. utility.group[group].perms[g])
				end
			else
				CONS_Printf(p, "\x86" .. "- Group is empty.")
			end
		end
	end
end

local function Cmd_Groupperms (p, group, givetake, ...)
	if utility.HasPerms(p, "utility.group.perms", true, false) == true
		if group == nil
		or givetake == nil
			CONS_Printf(p, "Syntax: groupperms <group> <give/take> <permission1> <permission2> ...")
			return
		end
		if utility.group[group] == nil
			CONS_Printf(p, "That group does not exist.")
			return
		end
		if utility.CanModifyGroup(p, group) == false
			local bp, bg = utility.BestGroup(p)
			CONS_Printf(p, "You cannot change " .. group .. " because its priority is equal to or greater than yours. Your current priority is " .. tostring(bp) .. ".")
			return
		end
		if givetake ~= "give"
		and givetake ~= "take"
			CONS_Printf(p, "Please specify to give or take permissions.")
			return
		end
		local permset = {...}
		if #permset == 0
			CONS_Printf(p, "No permissions specified.")
			return
		end
		local success = ""
		local itexists = false
		for v=1,#permset do
			if #utility.group[group].perms > 0
				for n=1,#utility.group[group].perms do
					if utility.group[group].perms[n] == string.lower(permset[v])
						if givetake == "take"
							success = $1 .. " " .. permset[v]
							table.remove(utility.group[group].perms, n) --Take it
						end
						itexists = true
						break
					end
				end
				if itexists == false
				and givetake == "give"
					success = $1 .. " " .. permset[v] 
					table.insert(utility.group[group].perms, string.lower(permset[v])) --Give it!
				end
			else
				if givetake == "give"
					success = $1 .. " " .. permset[v]
					table.insert(utility.group[group].perms, string.lower(permset[v])) --Give it!
				end
			end
		end
		if success == ""
			success = "\x86" .. " None"
		end
		local dir
		if givetake == "give"
			dir = "given"
		else
			dir = "revoked"
		end
		CONS_Printf(p, "Group " .. group .. " had these permissions " .. dir ..":" .. success)
	end
end

local function Cmd_Userperms (p, other, givetake, ...)
	if utility.HasPerms(p, "utility.user.perms", false, false) == true
		if other == nil
		or givetake == nil
			CONS_Printf(p, "Syntax: userperms <node/name> <give/take> <permission1> <permission2> ...")
			return
		end
		local t = F_FindPlayer(other)
		if t == -1
			CONS_Printf(p, "That user does not exist.")
			return
		end
		local tp, tg = utility.BestGroup(players[t])
		if utility.CanModifyPriority(p, tp) == false
			local bp, bg = utility.BestGroup(p)
			CONS_Printf(p, "You cannot change " .. players[t].name .. "'s permissions because their priority is equal to or greater than yours. Your current priority is " .. tostring(bp) .. " and their priority is " .. tostring(tp) .. ".")
			return
		end
		if givetake ~= "give"
		and givetake ~= "take"
			CONS_Printf(p, "Please specify to give or take permissions.")
			return
		end
		local permset = {...}
		if #permset == 0
			CONS_Printf(p, "No permissions specified.")
			return
		end
		local target = players[t]
		local success = ""
		local itexists = false
		for v=1,#permset do
			if #target.utility.perm.user > 0
				for n=1,#target.utility.perm.user do
					if target.utility.perm.user[n] == string.lower(permset[v])
						if givetake == "take"
							success = $1 .. " " .. permset[v]
							table.remove(target.utility.perm.user, n) --Take it
						end
						itexists = true
						break
					end
				end
				if itexists == false
				and givetake == "give"
					success = $1 .. " " .. permset[v] 
					table.insert(target.utility.perm.user, string.lower(permset[v])) --Give it!
				end
			else
				if givetake == "give"
					success = $1 .. " " .. permset[v]
					table.insert(target.utility.perm.user, string.lower(permset[v])) --Give it!
				end
			end
		end
		if success == ""
			success = "\x86" .. " None"
		end
		local dir
		if givetake == "give"
			dir = "given"
		else
			dir = "revoked"
		end
		CONS_Printf(p, "User " .. target.name .. " had these permissions " .. dir ..":" .. success)
		utility.PermissionTell(target, "You had these permissions " .. dir ..":" .. success)
	end
end

local function Cmd_Creategroup (p, prename, priority, title, color)
	if utility.HasPerms(p, "utility.group.create", false, false) == true
		if prename == nil
			CONS_Printf(p, "Syntax: creategroup <group> [priority] [title] [color]")
			return
		end
		local name = string.lower(prename)
		local pri = 0
		if priority ~= nil
		and tonumber(priority) ~= nil
			pri = tonumber(priority)
		end
		if utility.CanModifyPriority(p, pri) == false
			local mypri, myg = utility.BestGroup(p)
			CONS_Printf(p, "You cannot create a group with a priority higher than your own. Your current priority is " .. tostring(mypri) .. ".")
			return
		end
		if title == nil
			title = ""
		end
		if color == nil
			color = "white"
		end
		if utility.group[name] ~= nil
			CONS_Printf(p, "The group \"" .. name .. "\" already exists.")
		else
			local colcode
			if utility.col[color] == nil
				color = "white"
			end
			colcode = utility.col[color]
			utility.group[name] = {
				["perms"] = {},
				["title"] = title,
				["priority"] = pri,
				["colstr"] = color,
				["color"] = colcode
			}
			CONS_Printf(p, "Created permission group \"" .. name .. "\".")
		end
	end
end

local function Cmd_Deletegroup (p, prename)
	if utility.HasPerms(p, "utility.group.delete", false, false) == true
		if prename == nil
			CONS_Printf(p, "Syntax: deletegroup <group>")
			return
		end
		local name = string.lower(prename)
		if utility.group[name] == nil
			CONS_Printf(p, "The group \"" .. name .. "\" doesnt exist.")
		else
			if name == "default"
				CONS_Printf(p, "You cannot delete default.")
				return
			end
			if utility.CanModifyGroup(p, name) == false
				local mypri, myg = utility.BestGroup(p)
				CONS_Printf(p, "You cannot delete a group with a priority higher than your own. Your current priority is " .. tostring(mypri) .. ".")
				return
			end
			utility.group[name] = nil
			CONS_Printf(p, "Deleted permission group \"" .. name .. "\".")
			for play in players.iterate do
				if #play.utility.perm.group ~= 0
					for g=1,#play.utility.perm.group do
						if play.utility.perm.group[g] == name
							table.remove(play.utility.perm.group, g)
							utility.PermissionTell(play, "You are no longer part of the group \"" .. name .. "\" because it was removed!")
							break
						end
					end
				end
			end
		end
	end
end

local function Cmd_Usergroup (p, other, givetake, ...)
	if utility.HasPerms(p, "utility.user.groups", true, false) == true
		if other == nil
		or givetake == nil
			CONS_Printf(p, "Syntax: usergroup <node/name> <give/take> <group1> <group2> ...")
			return
		end
		local t = F_FindPlayer(other)
		if t == -1
			CONS_Printf(p, "That user does not exist.")
			return
		end
		if givetake ~= "give"
		and givetake ~= "take"
			CONS_Printf(p, "Please specify to give or take groups.")
			return
		end
		local groupset = {...}
		if #groupset == 0
			CONS_Printf(p, "No groups specified.")
			return
		end
		local target = players[t]
		local success = ""
		local itexists = false
		for v=1,#groupset do
			if groupset[v] == "default"
				CONS_Printf(p, "\x82" .. "WARNING" .. "\x80" .. ": You cannot give/take the default group.")
			else
				if utility.group[groupset[v]] ~= nil
					if utility.CanModifyGroup(p, groupset[v]) == true
						if #target.utility.perm.group > 0
							for n=1,#target.utility.perm.group do
								if target.utility.perm.group[n] == groupset[v] 
									if givetake == "take"
										success = $1 .. " " .. groupset[v]
										table.remove(target.utility.perm.group, n) --Take it
									end
									itexists = true
									break
								end
							end
							if itexists == false
							and givetake == "give"
								success = $1 .. " " .. groupset[v] 
								table.insert(target.utility.perm.group, groupset[v]) --Give it!
							end
						else
							if givetake == "give"
								success = $1 .. " " .. groupset[v]
								table.insert(target.utility.perm.group, groupset[v]) --Give it!
							end
						end
					else
						local bp, bg = utility.BestGroup(p)
						CONS_Printf(p, "You cannot add/remove " .. groupset[v] .. " because its priority is equal to or greater than yours. Your current priority is " .. tostring(bp) .. ".")
					end
				end
			end
		end
		if success == ""
			success = "\x86" .. " None"
		end
		local dir
		if givetake == "give"
			dir = "given"
		else
			dir = "revoked"
		end
		CONS_Printf(p, "User " .. target.name .. " had these groups " .. dir ..":" .. success)
		utility.PermissionTell(target, "You had these groups " .. dir ..":" .. success)
	end
end

local function Cmd_Group (p, name, meta, param)
	if name == nil
		CONS_Printf(p, "Syntax: group <group> <title/priority/color/rename> <parameter> - <title>")
	end
	if utility.group[name] == nil
		CONS_Printf(p, "That group doesnt exist.")
		return
	else
		if utility.CanModifyGroup(p, name) == false
			local bp, bg = utility.BestGroup(p)
			CONS_Printf(p, "You cannot change " .. name .. " because its priority is equal to or greater than yours. Your current priority is " .. tostring(bp) .. ".")
			return
		end
	end
	if meta == nil
		meta = "none"
	else
		if param == nil
			CONS_Printf(p, "You need a parameter.")
		end
	end
	if meta == "title"
		if utility.HasPerms(p, "utility.group.title", false, false) == false then return end
		utility.group[name].title = param
		CONS_Printf(p, "Set the group's title to " .. param .. ".")
	elseif meta == "priority"
		if utility.HasPerms(p, "utility.group.priority", false, false) == false then return end
		if tonumber(param) == nil
			CONS_Printf(p, "Please use a valid integer.")
			return
		end
		if utility.CanModifyPriority(p, tonumber(param))
			utility.group[name].priority = tonumber(param)
			CONS_Printf(p, "Set the group's priority to " .. param .. ".")
		else
			local bp, bg = utility.BestGroup(p)
			CONS_Printf(p, "You cannot change " .. name .. " because its priority would become equal to or greater than yours. Your current priority is " .. tostring(bp) .. ".")
		end
	elseif meta == "color"
		if utility.HasPerms(p, "utility.group.color", false, false) == false then return end
		local newcolor = ""
		local colstring = string.lower(param)
		if utility.col[colstring] == nil
			CONS_Printf(p, "Valid colors: red, orange, yellow, green, blue, purple, grey, white")
			return
		else
			utility.group[name].color = utility.col[colstring]
			utility.group[name].colstr = colstring
			CONS_Printf(p, "Set the group's color to " .. colstring .. ".")
		end
	elseif meta == "rename"
		if utility.HasPerms(p, "utility.group.rename", false, false) == false then return end
		if utility.group[param] ~= nil
			CONS_Printf(p, "You cannot rename a group to a group that already exists.")
			return
		elseif name == "default"
			CONS_Printf(p, "You cannot rename the default group.")
			return
		elseif name == param
			CONS_Printf(p, "You cannot rename a group to itself.")
			return
		else
			for play in players.iterate do
				if #play.utility.perm.group ~= 0
					for g=1,#play.utility.perm.group do
						if play.utility.perm.group[g] == name
							utility.PermissionTell(play, "The group \"" .. name .. "\" was renamed to \"" .. param .. "\".")
							table.remove(play.utility.perm.group, g)
							table.insert(play.utility.perm.group, param)
							break
						end
					end
				end
			end
			utility.group[param] = utility.group[name]
			utility.group[name] = nil
			CONS_Printf(p, "Group rename successful.")
		end
	else
		if utility.HasPerms(p, "utility.group.info", true, false) == false then return end
		CONS_Printf(p, "\x82" .. "Information about the group \"" .. name .. "\":")
		CONS_Printf(p, "- Title: " .. utility.group[name].title)
		CONS_Printf(p, "- Priority: " .. tostring(utility.group[name].priority))
		CONS_Printf(p, "- Color: " .. utility.group[name].color .. utility.group[name].colstr)
		CONS_Printf(p, "\x83" .. "Permissions for this group: ")
		if #utility.group[name].perms > 0
			for g=1,#utility.group[name].perms
				CONS_Printf(p, "- " .. utility.group[name].perms[g])
			end
		else
			CONS_Printf(p, "\x86" .. "- No permissions.")
		end
	end
end

local function DeletusMaximus ()
	utility.group = {}
	utility.group["default"] = {
		perms = {},
		title = "",
		priority = 0,
		color = "\x80",
		colstr = "white"
	}
	for p in players.iterate do
		p.utility.perm = {}
		p.utility.perm.group = {"default"}
		p.utility.perm.user = {}
	end
end

local function Cmd_ClearPerms (p)
	if utility.HasPerms(p, "utility.perms.clear", false, false) == true
		DeletusMaximus()
		CONS_Printf(p, "All permissions cleared. If this was a mistake, you should probably use defaultperms in the console.")
	end
end

local function Cmd_DefaultPerms (p)
	if utility.HasPerms(p, "utility.perms.default", false, false) == true
		DeletusMaximus()
		LoadDefaultPerms()
		CONS_Printf(p, "Default permissions loaded.")
	end
end

local function InitGroups(s)
	-- if io ~= nil
	-- else
		COM_BufInsertText(s, "exec utility\\exec\\permgroups.utl")
	-- end
end 

local function Cmd_LoadPerms (p)
	if utility.HasPerms(p, "utility.perms.load", false, false) == true
		CONS_Printf(p, "Attempting to load server's permissions. This will fail if the utility folder-based perms doesn't exist or is in an unexpected location.")
		InitGroups(server)
	end
end


local function Cmd_Helpop (p, ...)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.helpop", true, false) == false then return end
	if p.utility.helpop > 0
		CONS_Printf(p, "You must wait " .. tostring(p.utility.helpop/TICRATE) .. " seconds before using helpop. Consider what you want to say in the meantime.")
		return
	end
	local words = {...}
	if #words == 0 then
		CONS_Printf(p, "You must at least supply a message.")
		return
	end
	local s = ""
	for x=1,#words do
		if s ~= ""
			s = s .. " "
		end
		s = s .. words[x]
	end
	local helpmsg = p.name .. ": " .. s .. " [" .. utility.RandChar(8) .. "]"
	table.insert(utility.helpop, 1, helpmsg)
	p.utility.helpop = 180*TICRATE
	for adm in players.iterate do
		if utility.HasPerms(adm, "utility.cmd.helpop.listen", true, true)
			CONS_Printf(adm, "\x87" .. "[" .. "\x85" .. "Helpop" .. "\x87" .. "] " .. "\x87" .. helpmsg)
			S_StartSound(nil, sfx_s3kb7, adm)
		end
	end
end

local function Cmd_ListHelpop (p, s)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.helpop.list", true, false) == false then return end
	CONS_Printf(p, "Helpop messages from newest to oldest:")
	if #utility.helpop == 0
		CONS_Printf(p, "-- There are no messages. Everyone being nice? --")
	else
		for w=1,#utility.helpop do
			CONS_Printf(p, "[" .. tostring(w) .. "] " .. utility.helpop[w])
		end
		CONS_Printf(p, "Use the string of letters following the message to search the logfile for the incident.")
	end
end

local function NewLogin(myname, mypass, mypower)
	if myname ~= nil
	and mypass ~= nil
		local num = #utility.login + 1
		print(tostring(myname) .. " " .. tostring(mypass) .. " " .. tostring(mypower))
		utility.login[num] = {
			name = myname,
			pass = passwordHash(mypass),
			power = mypower
		}
		return true
	else
		return false
	end
end


local function Cmd_CreateLogin (p, name, password, power)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.login.create", true, false) == false then return end
	if name == nil
	or password == nil
	or power == nil
		CONS_Printf(p, "Syntax: createlogin <name> <password> <group> where <group> is the group they should be given on login.")
	else
		local stradmin = string.lower(power)
		if utility.group[power] == nil
			CONS_Printf(p, "The group " .. stradmin .. " doesn't exist.")
		else
			if utility.CanModifyGroup(p, stradmin) == true
				NewLogin(name, password, stradmin)
				CONS_Printf(p, "Login data for " .. name .. " saved.")
				utility.ConsoleTell("Login for name \"" .. name .. "\" with \"" .. stradmin .. "\" usergroup was created by " .. utility.TeamedName(p))
			else
				local bp, bg = utility.BestGroup(p)
				CONS_Printf(p, "You cannot acreate a login for " .. stradmin .. " because its priority is equal to or greater than yours.  Your current priority is " .. tostring(bp) .. ".")
			end
		end
	end
end

local function Cmd_UtilLogin (p, name, password)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.login", true, false) == false then return end
	if name == nil
	or password == nil
		CONS_Printf(p, "Syntax: utillogin <name> <password>")
	else
		local loginsuccess = false
		if #utility.login == 0
			CONS_Printf(p, "Password failed.")
		else
			--h
			for h=1,#utility.login do
				if utility.login[h].name == name
					local hashpass = passwordHash(password)
					if hashpass == utility.login[h].pass
						local getgroup = utility.login[h].power
						if utility.group[getgroup] == nil
							for play in players.iterate do
								utility.PermissionTell(play, "\x84" .. p.name .. "\x80" .. " logged in tried to get usergroup " .. "\x84" .. getgroup .. "\x80" .. " but it did not exist anymore. Contact an administrator" )
							end
						else
							table.insert(p.utility.perm.group, 1, utility.login[h].power)
							for play in players.iterate do
								utility.PermissionTell(play, "\x84" .. p.name .. "\x80" .. " logged in and got usergroup " .. "\x84" .. getgroup .. "\x80" .. "." )
							end
						end
						return
					end
				end
			end
			CONS_Printf(p, "Password failed.")
		end
	end
end

local function Cmd_List (p)
	if p.utility == nil then return end
	if utility.HasPerms(p, "utility.cmd.list", true, false) == false then return end
	local plist = {}
	local glist = {}
	local num = 0
	--Gather the data we need
	for play in players.iterate do
		if play.utility ~= nil
			local n, g = utility.BestGroup(play)
			local pn = play.name
			if play ~= server
				--Make a group section if necessary, and sort names
				if plist[g] == nil
					plist[g] = {pn}
					num = $1 + 1
					if #glist > 0
						for r=1,#glist do
							if utility.group[glist[r]].priority < utility.group[g].priority
								table.insert(glist, r, g)
								break
							else
								if utility.group[glist[r]].priority == utility.group[g].priority
								and string.lower(glist[r]) > string.lower(g)
									table.insert(glist, r, g)
									break
								elseif r == #glist
									table.insert(glist, g)
									break
								end
							end
						end
					else
						glist = {g}
					end
				else
					for q=1,#plist[g] do
						if string.lower(plist[g][q]) > string.lower(pn)
							table.insert(plist[g], q, pn)
							num = $1 + 1
							break
						elseif q == #plist[g]
							table.insert(plist[g], pn)
							num = $1 + 1
							break
						end
					end
				end
			end
		end
	end
	-- Sort everything into a list of online players based on group name, priority, and player name.
	if server.isdedicated == false
		num = $1 + 1
	end
	if num == 0
		CONS_Printf(p, "\0x82" .. "There is nobody here.")
		return
	end
	CONS_Printf(p, "\x82" .. "List of " .. tostring(num) .. " players.")
	if server.isdedicated == false
		--Put the server at the top. They're special.
		CONS_Printf(p,"\x81" .. "Server" .. "\x80" .. ":")
		CONS_Printf(p, "\x85" .. "- " .. server.name)
	end
	--Print out the groups, if there are any besides the server.
	if #glist > 0
		for k=1,#glist do
			local curgroup = glist[k]
			CONS_Printf(p, tostring(utility.group[curgroup].color) .. curgroup .. "\x80" .. ":")
			for j=1,#plist[curgroup] do
				CONS_Printf(p, "\x86" .. "- " .. plist[curgroup][j])
			end
		end
	end
end

--Adding all the commands in the table! Whew.
utility.AddUtilCommand("util", "Lists you Utility's additional commands and variables. If you supply a command or console variable as a parameter, it will give you a description on said command/variable. If you supply the parameter \"short\", you will be given a condensed list, like seen in the vanilla help menu. NOTE: To add your own commands to this list, please use utility.AddUtilCommand() and utility.AddUtilVar()", Cmd_Util, 0)
utility.AddUtilCommand("csay", "This command lets you send a notice to all players. Syntax: csay <message> - This will send a notice command for 5 seconds. The notice command will give you the ability to change the time frame. Only usable by the Server/Admin", Cmd_Csay, 0)
utility.AddUtilCommand("notice", "This command lets you add a notice to the global notice queue. Your name will be added to it automatically. Syntax: notice <seconds> <message> [delay] - seconds is the number of seconds you want it to be displayed for, and message is the message to show. A delay in seconds between having this appear is optional. If not supplied, it will be zero. To clear all notices in the queue, use a seconds value of 0. Only usable by the Server/Admin", Cmd_Notice, 0)
utility.AddUtilCommand("gametype", "This command, when not given a parameter, will check the current gametype. When given a parameter, it will seek the first available map for that gametype, and warp you to it. You can use either names, or numbers. coop=0, competition=1, race=2, match=3, teammatch=4, tag=5, hideandseek=6, ctf=7", Cmd_Gametype, 0)
utility.AddUtilCommand("vote", "A command that will let you vote in a callvote poll. Use a parameter of yes and no to vote yes and no respectively. This command is only usable in non-splitscreen multiplayer, when a poll is in progress,", Cmd_Vote, 0)
utility.AddUtilCommand("cancelvote", "This forcibly stops a poll that is in progress, nullifying its result. This command is only usable in non-splitscreen multiplayer, when a poll is in progress.", Cmd_Cancelvote, 0)
utility.AddUtilCommand("votepermission", "Allows the control of the vote permission variables. Syntax: votepermission <command> [allow/deny] - When allow/deny is not specified, it will tell you the current setting. You can see the list of votable commands with \"showvotecmds\". Alternatively, you can change the util_vote_* console variables.", Cmd_Votepermission, 0)
utility.AddUtilCommand("afk", "Toggles you between AFK mode, which will make you transparent. You will also count towards exiting the level. Each time you leave AFK mode, you have a 30-second cooldown before you can use it again. Multiplayer Co-Op only.", Cmd_Afk, 0)
utility.AddUtilCommand("afk2", "Player 2 equivalent of command \"afk\" only designed for splitscreen play.", Cmd_Afk2, 2)
utility.AddUtilCommand("showvotecmds", "This will list the commands that can be used in the callvote command. It will also list which commands can be polled by anyone, or the server/admin only.", Cmd_Showvotecmds, 0)
utility.AddUtilCommand("callvote", "This allows a player to start a vote to execute a specified command. To respond in the poll, use \"vote yes\" or \"vote no\" in the console. Syntax: callvote <command and parameter> [reason] - The parameter for the command is not always present; take \"exitlevel\" for example, which has no parameter. The reason is optional. If you are not the server or an admin, you incurr a 300 second cooldown before the next time you can call a vote.", Cmd_Callvote, 0)
utility.AddUtilCommand("silence", "Silences a user, disallowing them from using normal chat and team chat. NOTE: Does not stop sayto. It is up to individual players to block private messages. Syntax: silence <node/name> [seconds] [reason] - The name of the player can be used instead of the node number. Reason is optional. If the seconds value is not given, it will default to 60.", Cmd_Silence, 0)
utility.AddUtilCommand("unsilence", "The reverse of silencing a user, prematurely ending their silent treatment. Syntax: silence <node/name> - The name of the player can be used instead of the node number.", Cmd_Unsilence, 0)
utility.AddUtilCommand("ignore", "This will permanently ignore the target player and all their communication. NOTE: This is only local to you, others will be able to see their chatter if they allow it. If the target player leaves, the ignore is lifted. Syntax: ignore <node/name> - The name of the player can be used instead of the node number.", Cmd_Ignore, 0)
utility.AddUtilCommand("unignore", "This will undo an ignore on the target player. Syntax: unignore <node/name> - The name of the player can be used instead of the node number.", Cmd_Unignore, 0)
utility.AddUtilCommand("changemus", "Changes the music for everyone, like using tunes in the console. NOTE: Not updated for joining players.", Cmd_Changemus, 0)
utility.AddUtilCommand("changesky", "Changes the sky for everyone.", Cmd_Changesky, 0)
utility.AddUtilCommand("sayadmin", "Allows anyone with @ or higher terminal permission or vanilla admin/host privilege to talk amongst each other in an admin-only chat.", Cmd_SayAdmin, 0)
utility.AddUtilCommand("macrolist", "Displays all the currently available chat macro replacements along with example return values.", Cmd_MacroList, 0)
utility.AddUtilCommand("dediname", "Rename as the dedicated server. Only useable by a dedicated server, obviously.", Cmd_Dediname, 0)
utility.AddUtilCommand("utilversion", "Prints out your current version of Utility.", Cmd_Utilversion, 0)
utility.AddUtilCommand("vanilla", "Performs a vanilla command in the server for you. Syntax: vanilla <cmd> <parameters> - Parameters may be as long as you wish.", Cmd_Vanilla, 0)
utility.AddUtilCommand("userperms", "Give or take a user permission nodes. Syntax: userperms <node/name> <give/take> <permission1> <permission2> ... - Permission is not case sensitive, it will be melted into lowercase.", Cmd_Userperms, 0)
utility.AddUtilCommand("groupperms", "Give or take a group permission nodes. Syntax: groupperms <group> <permission1> <permission2> ... - Permission is not case sensitive, it will be melted into lowercase.", Cmd_Groupperms, 0)
utility.AddUtilCommand("listperms", "List a user's permissions. Syntax: listperms [node/name]", Cmd_Listperms, 0)
utility.AddUtilCommand("creategroup", "Creates a user group. Syntax: creategroup <group> [priority] [title] [color] - [title] [priority] and [color] set the group's parameters", Cmd_Creategroup, 0)
utility.AddUtilCommand("deletegroup", "Removes a user group. Syntax: deletegroup <group> - Please be careful, deleting a group is a one-way process.", Cmd_Deletegroup, 0)
utility.AddUtilCommand("group", "Manages a group's metadata. Syntax: group <group> <title/priority/color/rename> <parameter> - <title> is the group's prefix in chat. <priority> is the group's title priority asa number. <color> is the group's title color.  <rename> renames it.", Cmd_Group, 0)
utility.AddUtilCommand("usergroup", "Manage a user's groups. Syntax: usergroup <node/name> <give/take> <group> - ", Cmd_Usergroup, 0)
utility.AddUtilCommand("clearperms", "Clear all permissions and permission groups.", Cmd_ClearPerms, 0)
utility.AddUtilCommand("defaultperms", "Set permissions back to Utility's default in-script permissions.", Cmd_DefaultPerms, 0)
utility.AddUtilCommand("loadperms", "Load permissions saves on the server. This will only work if you set up the utility folder's permission base.", Cmd_LoadPerms, 0)
utility.AddUtilCommand("helpop", "Sends a HelpOp message privately to all staff. These messages are also saved in a list for later review. Syntax: helpop <message>", Cmd_Helpop, 0)
utility.AddUtilCommand("listhelpop", "Lists all sent HelpOp messages.", Cmd_ListHelpop, 0)
utility.AddUtilCommand("createlogin", "Creates a name ans password combination for someone to log into later and get a usergroup. Syntax: createlogin <name> <password> <group>", Cmd_CreateLogin, 0)
utility.AddUtilCommand("utillogin", "Logs in to get a usergroup assigned to you. Password and name are required and are case-sensitive. Syntax: utillogin <name> <password>", Cmd_UtilLogin, 0)
utility.AddUtilCommand("list", "Lists all players by group. Use this to see who are the server staff.", Cmd_List, 0)

utility.badwordslong = {
	"fuck", "shit", "cunt", "git", "damn", "putos", "puto", "whore", "wanker", "wop", "vagina", "vag", "tit", "twat", "testicle", "tard", "slut", "nigger", "schlong", "scrote", "scrotum", "ruski", "cykablyat", "queef", "queer", "faggot",
	"fag", "penis", "pussies", "porchmonkey", "peckerhead", "polesmoker", "punta", "poonani", "poonany", "poontang", "kontol", "nutsack", "nigga", "negro", "niglet", "munging", "motherfuckin", "motherfucka", "mick", "lesbo", "lezzie",
	"lameass", "lardass", "jackass", "jizz", "junglebunny", "jigaboo", "jerkoff", "jerkass", "honkey", "handjob", "heeb", "goddamn", "damnit", "gook", "gooch", "gook", "gringo", "guido", "faggit", "fagget", "fellatio", "feltch",
	"fudgepacker", "dago", "dego", "dick", "dicc", "dildo", "dike", "dyke", "dooch", "douche", "cameltoe", "chode", "choad", "chinc", "chink", "cock", "cunnie", "cum", "cunnilingus", "chesticle", "carpetmuncher", "idioso",
	"porch monkey", "cyka blyat", "pecker head", "pole smoker", "mother fuckin", "mother fucka", "fudge packer", "hand job", "god damn", "fudge packer", "camel toe", "carpet muncher", "ass", "peeny", "weenie", "filtertestone"
}

utility.badwordsshort = {
	"fuck", "shit", "cunt", "git", "damn", "penis", "dick", "pussy", "cock", "puto", "cyka blyat", "cykablyat", "whore", "nigger", "faggot", "filtertesttwo"
}

utility.MakeStars = function(num)
	local stars = ""
	for c=1,num do
		stars = $1 .. "*"
	end
	return stars
end

utility.ChatFilter = function(source, msg)
	if utility.chat.filter.value == 0
	or utility.HasPerms(source, "utility.msg.override.filter", true, true) == true
		return msg --Disable if the server doesn't want to filter the chat, of if the user overrides this feature,
	end
	local badlist = {}
	if utility.chat.filter.value == 1
		badlist = utility.badwordsshort
	else
		badlist = utility.badwordslong
	end
	local newmsg = string.lower(msg)
	local msg2 = msg
	local replacement = ""
	for x=1,#badlist
		msg2 = string.gsub($1, badlist[x], utility.MakeStars(string.len(badlist[x])))
	end
	return msg2
end

utility.TryMsg = function(source, msgtype, target) --See if we can send this message to this player. This does not actually send a message!
	if source.utility == nil then return false end
	if target.utility == nil then return false end
	if target.utility ~= nil
		if target.utility.ignore[utility.PlayerToNode(source)] == true
		and utility.HasPerms(source, "utility.msg.override.ignore", true, true) == false
			if source ~= target and msgtype ~= 4
				return false
			end
		end
	end
	if msgtype == 1
		if utility.ExtendedTeam(source) == utility.ExtendedTeam(target)
		or utility.ExtendedTeam(target) == 0 --Spectator
			return true
		else
			return false
		end
	elseif msgtype == 4 --Admin chat.
		if utility.HasPerms(target, "utility.msg.admin", true, true) == true
			return true
		else
			return false
		end
	end
	return true
end

utility.MsgOutput = function(player, msg, msgtype, target, name1, name2)
	local message = ""
	local action = false
	local name = utility.TeamedName(player)
	local group = utility.GroupName(player)
	if string.lower(string.sub(msg, 1, 4)) == "/me "
		message = "\x82" .. "* %s " .. "\x82" .. string.sub(msg, 5)
		action = true
	else
		message = msg
	end
	if msgtype == 0
		if action == true
			return group .. string.format(message, name)
		else
			return group .. string.format(utility.msg.overlay[7], name, msg)
		end
	elseif msgtype == 1
		if action == true
			return string.format(utility.msg.overlay[utility.ExtendedTeam(player)], string.format(message, name))
		else
			return string.format(utility.msg.overlay[utility.ExtendedTeam(player)], player.name .. ": " .. msg)
		end
	elseif msgtype == 2
		if player == target
			return string.format(utility.msg.overlay[6], name1, name2, string.format(message, name))
		else
			return string.format(utility.msg.overlay[8], name1, name2, string.format(message, name))
		end
	elseif msgtype == 4
		if action == true
			return group .. string.format(utility.msg.overlay[9], string.format(message, name))
		else
			return group .. string.format(utility.msg.overlay[9], name .. ": " .. msg)
		end
	end
end

utility.DoMsg = function(source, target, msg, msgtype, name1, name2) --Actually sends a message if it can.
	if source.utility == nil then return end
	if target.utility == nil then return end
	if utility.TryMsg(source, msgtype, target) == true
		if msgtype == 2
			S_StartSound(nil, 154, target)
		else
			S_StartSound(nil, sfx_radio, target)
		end
		chatprintf(target, utility.MsgOutput(source, msg, msgtype, target, name1, name2))
	end
end

utility.PostMsgToPlayers = function(source, msg, msgtype, target)
	if msgtype == 2
		utility.DoMsg(source, source, msg, msgtype, utility.TeamedName(source), utility.TeamedName(target))
		utility.DoMsg(source, target, msg, msgtype, utility.TeamedName(source), utility.TeamedName(target))
	else
		for player in players.iterate
			utility.DoMsg(source, player, msg, msgtype)
		end
		if server.isdedicated == true
			utility.DoMsg(source, server, msg, msgtype)
		end
	end
end


utility.NewMsg = function(source, flags, target, msg)
	if source.utility == nil
		chatprintf(source, "Your player variables are not ready yet!")
		return
	end
	--Various permission checks based on type of message.
	if flags == 0
	and utility.HasPerms(source, "utility.msg.public", true, true) == false
		return
	end
	if flags == 1
	and utility.HasPerms(source, "utility.msg.team", true, true) == false
		return
	end
	if flags == 2
	and utility.HasPerms(source, "utility.msg.private", true, true) == false
		return
	end
	source.utility.idle = 0 --Reset idle timer when you talk.
	if utility.spam.repeats.value == 0
	and source ~= server
	and utility.HasPerms(source, "utility.msg.override.spam", true, true) == false
		if source.utility.spam.lastmsg == nil
			source.utility.spam.lastmsg = msg
		else
			if source.utility.spam.lastmsg == msg
				chatprintf(source, "You're repeating yourself.")
				return true
			end
		end
	end
	source.utility.spam.lastmsg = msg
	if flags ~= 4 --Allow admin chatter.
		if source.utility ~= nil
			if source.utility.silenced == true
				chatprintf(source, "You cannot send global or team messages for " .. tostring(source.utility.quiettime / TICRATE) .. " seconds.")
				return true
			end
			if utility.chat.slow.value ~= 0
			and utility.HasPerms(source, "utility.msg.override.slow", true, true) == false
				if source.utility.slowmode == 0
					source.utility.slowmode = utility.chat.slow.value * TICRATE
				else
					chatprintf(source, "Slow mode is active. Please wait " .. tostring(source.utility.slowmode / TICRATE) .. " seconds.")
					return true
				end
			end
		end
	end
	local macromsg = utility.ChatMacro(source, msg)
	-- In-Chat Command Interrupter
	local interrupter = macromsg
	if utility.GetChar(macromsg, 1) == "/"
	and string.lower(string.sub(macromsg, 1, 3)) ~= "/me" --Escape for /me users.
		if utility.GetChar(macromsg, 2) ~= "/"
		and utility.GetChar(macromsg, 2) ~= " "
			interrupter = string.sub(macromsg, 2)
			chatprintf(source, "Exec command: " .. "\x84" .. interrupter)
			COM_BufInsertText(source, interrupter) --Let them run their command.
			return true
		else
			interrupter = utility.GetChar(macromsg, 1) .. string.sub(macromsg, 3)
		end
	end
	local message = utility.ChatFilter(source, interrupter)
	utility.PostMsgToPlayers(source, message, flags, target)
	if utility.spam.time.value == 0
	or utility.spam.num.value == 0
		source.utility.spam.history = {}
	else
		table.insert(source.utility.spam.history, 1, source.jointime)
		local numlines = #source.utility.spam.history
		while numlines > utility.spam.num.value
			table.remove(source.utility.spam.history, (utility.spam.num.value + 1)) --Remove the last entry
			numlines = $1 - 1
		end
		if numlines == utility.spam.num.value
			if abs(source.utility.spam.history[1] - source.utility.spam.history[numlines]) <= (utility.spam.time.value * TICRATE) --You're spamming!
			and source ~= server --But we can "trust" the server. If you don't like the server spamming, go find another server or make your own. Science.
				if utility.HasPerms(source, "utility.msg.override.spam", true, true) == false --Here's the override coming in...
					if source.utility.quiettime == 0
						A_SilencePlayer(nil, source, 60, utility.msg.spam[flags])
					end
				end
			end
		end
	end
	return true
end

addHook("PlayerMsg", utility.NewMsg)

local client
local clientval = 0

utility.CheckRedFlag = function(mobj, touch)
	for play in players.iterate
		if play.ctfteam == 1
			return false
		end
	end
	touch.player.utility.noflag = TICRATE*5
	return true
end

utility.CheckBlueFlag = function(mobj, touch)
	for play in players.iterate
		if play.ctfteam == 2
			return false
		end
	end
	touch.player.utility.noflag = TICRATE*5
	return true
end

--Stops players from picking up a CTF flag when the other team has no players.
addHook("TouchSpecial", utility.CheckRedFlag, MT_REDFLAG)
addHook("TouchSpecial", utility.CheckBlueFlag, MT_BLUEFLAG)

addHook("ThinkFrame", do
	if server.inittimer == nil
		server.inittimer = 0
	end
	if server.inittimer == 10 --Boot up reminder.
		CONS_Printf(server, "\x83" .. "Utility has a permission node system. Use util for command help. You can use clearperms to start from scratch or defaultperms to set it to default. If you have the utiltiy folder, you can also use loadperms to load your saved permissions in there. You can also use exec to set up your own manually!")
	end
	server.inittimer = $1 + 1
	for player in players.iterate
		if player.utility == nil --Set up the player's variables.
			player.utility = {}
			player.utility["silenced"] = false
			player.utility["quiettime"] = 0 --Silence time still remaining.
			player.utility["ignore"] = {} --Ignore table.
			player.utility["voted"] = 0
			player.utility["votedelay"] = 30 * TICRATE
			player.utility["afk"] = false
			player.utility["afkdelay"] = 0
			player.utility["idle"] = 0
			player.utility["noflag"] = 0
			player.utility["slowmode"] = 0
			player.utility.lock = {} --For AFK mode.
			player.utility.lock["x"] = 0
			player.utility.lock["y"] = 0
			player.utility.lock["z"] = 0
			player.utility.lock["momx"] = 0
			player.utility.lock["momy"] = 0
			player.utility.lock["momz"] = 0
			player.utility.spam = {}
			player.utility.spam["history"] = {} --List of previous times the user sent a message. Used for spam prevention.
			player.utility.levelcomplete = false
			player.utility.perm = {}
			player.utility.perm.group = {"default"}
			player.utility.perm.user = {}
			player.utility.helpop = 30*TICRATE
			for a=0,31 do --Node ignore table
				player.utility.ignore[a] = false
			end
			COM_BufInsertText(player, "bind \"-\" \"vote yes\"") --I've had debate over these being here. But, quite frankly, a lot more have been making use of it
			COM_BufInsertText(player, "bind \"=\" \"vote no\"") --than people complaining about it, so it's going to stay there. Sorry.
		end
	end
	if utility.coop.timelimit.value ~= 0
	and gametype == GT_COOP
		local tics = utility.coop.timelimit.value * TICRATE * 60
		if tics == leveltime
			COM_BufInsertText(server, "exitlevel")
		end
	end
	server.isdedicated = false
	if server.mo == nil
	and server.jointime == 0
	and server.spectator == false
		server.isdedicated = true
		if server.utility == nil --Set up the server's variables in case this is a dedicated server.
			server.utility = {}
			server.utility["silenced"] = false
			server.utility["quiettime"] = 0
			server.utility["ignore"] = {}
			server.utility["voted"] = 0
			server.utility["votedelay"] = 30 * TICRATE
			server.utility["afk"] = false
			server.utility.spam = {}
			server.utility.spam["history"] = {}
			server.utility.perm = {}
			server.utility.perm.group = {"default"}
			server.utility.perm.user = {}
		end
	else
		server.isdedicated = false
	end
	if server.globals == nil --Set up the global variables used by everyone.
		server.globals = {}
		server.globals["vote"] = {}
		server.globals.vote["time"] = -3500
		server.globals.vote["cmd"] = "Nothing"
		server.globals.vote["exec"] = "The detest"
		server.globals.vote["yes"] = 0
		server.globals.vote["no"] = 0
		server.globals.vote["total"] = 0
		server.globals.vote["reason"] = "None."
		server.globals.vote["started"] = false
		server.globals.vote["result"] = "none"
		server.globals["notice"] = {}
		server.globals.notice["num"] = 0
		server.globals.notice["msg"] = {[0] = "None"}
		server.globals.notice["duration"] = {[0] = 0}
		server.globals.notice["delay"] = {[0] = 0} --How long to wait until the next notice.
		server.globals.notice["color"] = {[0] = 0} --To be added!
		server.globals.notice["current"] = 0 --The notice number we are currently on.
	end
	if server.globals ~= nil
		if server.globals.vote.started == true
			if server.globals.vote.time > 0
				server.globals.vote.time = $1 - 1
				local numplayers = 0
				if Vote_IsVoteDone(utility.TotalVoters()) > 0
					server.globals.vote.time = 0
				end
			elseif server.globals.vote.time > -175
				if server.globals.vote.yes > server.globals.vote.no
					server.globals.vote.result = "yes"
				else
					server.globals.vote.result = "no"
				end
				server.globals.vote.time = $1 - 1
			elseif server.globals.vote.time == -175
				if server.globals.vote.result == "yes"
					COM_BufInsertText(server, server.globals.vote.exec)
				end
				F_ResetVote()
			end
		end
		if server.globals.notice.num > 0
			local cur = server.globals.notice.current
			--print(tostring(cur) .. " " .. tostring(server.globals.notice.duration[cur]))
			if server.globals.notice.duration[cur] == 0
				server.globals.notice.current = cur + 1
				if server.globals.notice.msg[cur+1] == nil --Notice board is finished.
					F_RestartNotice()
					server.globals.notice.current = 0
				else
					print(server.globals.notice.msg[cur+1])
				end
			else
				if server.globals.notice.duration[cur] == server.globals.notice.delay[cur]
					S_StartSound(nil, 140)
				end
				server.globals.notice.duration[cur] = $1 - 1
			end
		end
	end
	if server.isdedicated == true
		for player in players.iterate
			if client ~= nil
				if player == client
				and clientval == 2
					COM_BufInsertText(player, "updatename") --Update the dedicated server's name.
					clientval = 3
				end
			end
		end
	end
	for player in players.iterate --Player-based timers and triggers.
		if player.utility ~= nil --Must be a prepared player.
			if player.utility.helpop > 0
				player.utility.helpop = $1 - 1
			end
			if player.utility.slowmode > 0
				player.utility.slowmode = $1 - 1
			end
			if player.utility.afk == true
				if leveltime == 1
					player.utility.lock["x"] = player.mo.x
					player.utility.lock["y"] = player.mo.y
					player.utility.lock["z"] = player.mo.z
					player.utility.lock["momx"] = 0
					player.utility.lock["momy"] = 0
					player.utility.lock["momz"] = 0
					player.exiting = 1
				end
				if leveltime > 1
					P_TeleportMove(player.mo, player.utility.lock.x, player.utility.lock.y, player.utility.lock.z)
					player.mo.momx = player.utility.lock.momx
					player.mo.momy = player.utility.lock.momy
					player.mo.momz = player.utility.lock.momz
					if player.utility.levelcomplete == false
						player.realtime = 209999
					end
				end
				if player.mo ~= nil
					player.mo.flags2 = $ | MF2_SHADOW
				end
			else
				if player.exiting > 0
					player.utility.levelcomplete = true
				else
					if multiplayer
						if player.mo ~= nil
							if player.mo.momx < 3*FRACUNIT
							and player.mo.momy < 3*FRACUNIT
							and player.mo.momz < 3*FRACUNIT
							and player.lives > 0
								player.utility.idle = $1 + 1
							else
								player.utility.idle = 0
							end
						end
						if player.utility.idle >= (utility.coop.afktimer.value * 35)
						and player.utility.afkdelay == 0
						and utility.coop.afktimer.value ~= 0
						and gametype == GT_COOP -- Or not co-op.
							CONS_Printf(player, "You've been marked as AFK for being idle too long.")
							utility.BecomeAFK(player)
							player.utility.idle = 0
						end
					end
				end
				if player.utility.afkdelay > 0
					player.utility.afkdelay = $1 - 1
				end
			end
			player.utility.votedelay = $1 - 1
			if player.utility.silenced == true
				player.utility.quiettime = $1 - 1
				if player.utility.quiettime == 0
					player.utility.silenced = false
					CONS_Printf(player, "Your silence has worn off.")
					utility.ConsoleTell("The silence for " .. utility.TeamedName(player) .. "\x86" .. " has worn off.")
				end
			end
			if player.utility.noflag > 0
				player.utility.noflag = $1 - 1
			end
		end
	end
	for a=0,31 do --Node ignore table
		if players[a] == nil
			if nodestatus[a] == true
				for player in players.iterate
					if player.utility ~= nil
						player.utility.ignore[a] = false --Reset ignores.
					end
				end
			end
			nodestatus[a] = false
		else
			nodestatus[a] = true
		end
	end
end)

hud.add(function (v, player)
	if server.globals ~= nil
		local num = server.globals.notice.current
		if num > 0
			if server.globals.notice.duration[num] <= server.globals.notice.delay[num]
				v.drawString(40, 120, server.globals.notice.msg[num], 0)
			end
		end
		if server.globals.vote.started == true
			if server.globals.vote.time > 0
				v.drawString(200, 8, "VOTE NOW", V_MONOSPACE|V_REDMAP, "center")
				v.drawString(200, 16, server.globals.vote.cmd, 0, "center")
				v.drawString(200, 24, "Reason: " .. server.globals.vote.reason, 0,  "center")
				v.drawString(200, 32, "Time left: " .. tostring(server.globals.vote.time / TICRATE), V_REDMAP, "center")
				v.drawString(200, 40, "Yes: " .. server.globals.vote.yes .. " No: " .. server.globals.vote.no, 0, "center")
			elseif server.globals.vote.time > -175
				if server.globals.vote.result == "yes"
					v.drawString(200, 16, "VOTE PASSED", V_MONOSPACE|V_REDMAP, "center")
				else
					v.drawString(200, 16, "VOTE FAILED", V_MONOSPACE|V_REDMAP, "center")
				end
			end
		end
		if utility.coop.timelimit.value ~= 0
		and gametype == GT_COOP
			local tics = (utility.coop.timelimit.value * TICRATE * 60) - leveltime
			if tics < (60*TICRATE)
			and tics > 0
				if tics < (10*TICRATE)
					v.drawString(160, 192, "EXITLEVEL IN " .. tostring(tics / TICRATE) .. " SECONDS.", V_REDMAP, "center")
				else
					v.drawString(160, 192, "EXITLEVEL IN " .. tostring(tics / TICRATE) .. " SECONDS.", V_YELLOWMAP, "center")
				end
			end
		end
	end
	if player.utility ~= nil
		if player.utility.noflag > 0
			v.drawString(160, 192, "No players on the other team!", V_REDMAP, "center")
		end
	end
end)

hud.add(function (catch, player)
	client = player
	if player.jointime < 70
		clientval = 0
	else
		if clientval < 2
			clientval = $1 + 1
		end
	end
end)

if utility.subversion == true
	print("\x83" .. "This is a sub-version (Not an MB release) so please report bugs you find.")
end